/*
 * This file we only ues its Country'name and countryCcode.
 * Copy from Atheros Wireless Driver.
 * For Country'name counldn't change, so we should be very cautious when fix this file
 * Rugmeng 20131203
 */
#ifndef __COUNTRY_NAME_H__
#define __COUNTRY_NAME_H__

#include "regulatory_domain.h"

typedef struct {
    HAL_CTRY_CODE        countryCode;
    HAL_REG_DOMAIN        regDmnEnum;
    const char*        isoName;
    const char*        name;
    u_int8_t
        allow11g      : 1,
        allow11aTurbo : 1,
        allow11gTurbo : 1,
        allow11ng20   : 1, /* HT-20 allowed in 2GHz? */
        allow11ng40   : 1, /* HT-40 allowed in 2GHz? */
        allow11na20   : 1, /* HT-20 allowed in 5GHz? */
        allow11na40   : 1; /* HT-40 allowed in 5GHz? */
    u_int16_t outdoorChanStart;
} COUNTRY_CODE_TO_ENUM_RD;

#define YES	1
#define NO     0
/* 
 * According to file "countryCode.h", we lose 7 country here
 * Country code: 44, 60, 480, 558, 600, 834, 800
 * We add them manually
 */
static const COUNTRY_CODE_TO_ENUM_RD ahCmnAllCountries[] = {
    {CTRY_DEBUG,       NO_ENUMRD,     "DB", "DEBUG",          YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_DEFAULT,     DEF_REGDMN,    "NA", "NO_COUNTRY_SET", YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_ALBANIA,     NULL1_WORLD,   "AL", "ALBANIA",        YES,  NO, YES, YES, YES,  NO,  NO, 7000 },
    {CTRY_ALGERIA,     NULL1_WORLD,   "DZ", "ALGERIA",        YES,  NO, YES, YES, YES,  NO,  NO, 7000 },
    {CTRY_ARGENTINA,   FCC3_WORLD,    "AR", "ARGENTINA",      YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_ARMENIA,     ETSI4_WORLD,   "AM", "ARMENIA",        YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_ARUBA,       ETSI1_WORLD,   "AW", "ARUBA",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_AUSTRALIA,   FCC3_WORLD,    "AU", "AUSTRALIA",      YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_AUSTRALIA2,  FCC6_WORLD,    "AU", "AUSTRALIA2",     YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_AUSTRIA,     ETSI1_WORLD,   "AT", "AUSTRIA",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_AZERBAIJAN,  ETSI4_WORLD,   "AZ", "AZERBAIJAN",     YES, YES, YES, YES, YES, YES, YES, 7000 },
/* Add manually, Code:40 , Bahamas*/
    {CTRY_BAHAMAS, DEF_REGDMN, "BS", "BAHAMAS", YES, YES, YES, YES, YES, YES, YES, 7000},
    {CTRY_BAHRAIN,     APL6_WORLD,    "BH", "BAHRAIN",        YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_BANGLADESH,  NULL1_WORLD,   "BD", "BANGLADESH",     YES,  NO, YES, YES, YES,  NO,  NO, 7000 },
    {CTRY_BARBADOS,    FCC2_WORLD,    "BB", "BARBADOS",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_BELARUS,     ETSI1_WORLD,   "BY", "BELARUS",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_BELGIUM,     ETSI1_WORLD,   "BE", "BELGIUM",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_BELGIUM2,    ETSI4_WORLD,   "BE", "BELGIUM2",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_BELIZE,      APL1_ETSIC,    "BZ", "BELIZE",         YES, YES, YES, YES, YES, YES, YES, 7000 },
/* Add manually, Code:60 ,Berumuda */
    {CTRY_BERMUDA, DEF_REGDMN, "BM", "BERUMUDA", YES, YES, YES, YES, YES, YES, YES, 7000},
    {CTRY_BOLIVIA,     APL1_ETSIC,    "BO", "BOLIVIA",        YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_BOSNIA_HERZ, ETSI1_WORLD,   "BA", "BOSNIA AND HERZEGOVINA", YES,  NO, YES, YES, YES, YES,  YES, 7000 },
    {CTRY_BRAZIL,      FCC3_WORLD,    "BR", "BRAZIL",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_BRUNEI_DARUSSALAM, APL6_WORLD, "BN", "BRUNEI DARUSSALAM", YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_BULGARIA,    ETSI1_WORLD,   "BG", "BULGARIA",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CAMBODIA,    ETSI1_WORLD,   "KH", "CAMBODIA",       YES, NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CANADA,      FCC3_FCCA,     "CA", "CANADA",         YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CANADA2,     FCC6_FCCA,     "CA", "CANADA2",        YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CHILE,       APL6_WORLD,    "CL", "CHILE",          YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CHINA,       APL1_WORLD,    "CN", "CHINA",          YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_COLOMBIA,    FCC1_FCCA,     "CO", "COLOMBIA",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_COSTA_RICA,  FCC1_WORLD,    "CR", "COSTA RICA",     YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_CROATIA,     ETSI1_WORLD,   "HR", "CROATIA",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CYPRUS,      ETSI1_WORLD,   "CY", "CYPRUS",         YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_CZECH,       ETSI1_WORLD,   "CZ", "CZECH REPUBLIC", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_DENMARK,     ETSI1_WORLD,   "DK", "DENMARK",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_DOMINICAN_REPUBLIC, FCC1_FCCA, "DO", "DOMINICAN REPUBLIC", YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_ECUADOR,     FCC1_WORLD,    "EC", "ECUADOR",        YES,  NO,  NO, YES, YES, YES,  NO, 7000 },
    {CTRY_EGYPT,       ETSI3_WORLD,   "EG", "EGYPT",          YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_EL_SALVADOR, FCC1_WORLD,    "SV", "EL SALVADOR",    YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_ESTONIA,     ETSI1_WORLD,   "EE", "ESTONIA",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_FINLAND,     ETSI1_WORLD,   "FI", "FINLAND",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_FRANCE,      ETSI1_WORLD,   "FR", "FRANCE",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_GEORGIA,     ETSI4_WORLD,   "GE", "GEORGIA",        YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_GERMANY,     ETSI1_WORLD,   "DE", "GERMANY",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_GREECE,      ETSI1_WORLD,   "GR", "GREECE",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_GREENLAND,   ETSI1_WORLD,   "GL", "GREENLAND",      YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_GRENADA,     FCC3_FCCA,     "GD", "GRENADA",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_GUAM,        FCC1_FCCA,     "GU", "GUAM",           YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_GUATEMALA,   FCC1_FCCA,     "GT", "GUATEMALA",      YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_HAITI,       ETSI1_WORLD,   "HT", "HAITI",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_HONDURAS,    FCC3_WORLD,    "HN", "HONDURAS",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_HONG_KONG,   FCC3_WORLD,    "HK", "HONG KONG",      YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_HUNGARY,     ETSI1_WORLD,   "HU", "HUNGARY",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_ICELAND,     ETSI1_WORLD,   "IS", "ICELAND",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_INDIA,       APL6_WORLD,    "IN", "INDIA",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_INDONESIA,   APL2_WORLD,    "ID", "INDONESIA",      YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_IRAN,        APL1_WORLD,    "IR", "IRAN",           YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_IRELAND,     ETSI1_WORLD,   "IE", "IRELAND",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_ISRAEL,      ETSI3_WORLD,   "IL", "ISRAEL",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_ITALY,       ETSI1_WORLD,   "IT", "ITALY",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_JAMAICA,     FCC3_WORLD,    "JM", "JAMAICA",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN,       MKK1_MKKA,     "JP", "JAPAN",          YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN1,      MKK1_MKKB,     "JP", "JAPAN1",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN2,      MKK1_FCCA,     "JP", "JAPAN2",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN3,      MKK2_MKKA,     "JP", "JAPAN3",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN4,      MKK1_MKKA1,    "JP", "JAPAN4",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN5,      MKK1_MKKA2,    "JP", "JAPAN5",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN6,      MKK1_MKKC,     "JP", "JAPAN6",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN7,      MKK3_MKKB,     "JP", "JAPAN7",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN8,      MKK3_MKKA2,    "JP", "JAPAN8",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN9,      MKK3_MKKC,     "JP", "JAPAN9",         YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN10,     MKK4_MKKB,     "JP", "JAPAN10",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN11,     MKK4_MKKA2,    "JP", "JAPAN11",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN12,     MKK4_MKKC,     "JP", "JAPAN12",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN13,     MKK5_MKKB,     "JP", "JAPAN13",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN14,     MKK5_MKKA2,    "JP", "JAPAN14",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN15,     MKK5_MKKC,     "JP", "JAPAN15",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN16,     MKK6_MKKB,     "JP", "JAPAN16",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN17,     MKK6_MKKA2,    "JP", "JAPAN17",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN18,     MKK6_MKKC,     "JP", "JAPAN18",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN19,     MKK7_MKKB,     "JP", "JAPAN19",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN20,     MKK7_MKKA2,    "JP", "JAPAN20",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN21,     MKK7_MKKC,     "JP", "JAPAN21",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN22,     MKK8_MKKB,     "JP", "JAPAN22",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN23,     MKK8_MKKA2,    "JP", "JAPAN23",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN24,     MKK8_MKKC,     "JP", "JAPAN24",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN25,     MKK3_MKKA,     "JP", "JAPAN25",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN26,     MKK3_MKKA1,    "JP", "JAPAN26",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN27,     MKK3_FCCA,     "JP", "JAPAN27",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN28,     MKK4_MKKA1,    "JP", "JAPAN28",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN29,     MKK4_FCCA,     "JP", "JAPAN29",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN30,     MKK6_MKKA1,    "JP", "JAPAN30",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN31,     MKK6_FCCA,     "JP", "JAPAN31",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN32,     MKK7_MKKA1,    "JP", "JAPAN32",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN33,     MKK7_FCCA,     "JP", "JAPAN33",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN34,     MKK9_MKKA,     "JP", "JAPAN34",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN35,     MKK10_MKKA,    "JP", "JAPAN35",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN36,     MKK4_MKKA,     "JP", "JAPAN36",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN37,     MKK9_FCCA,     "JP", "JAPAN37",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN38,     MKK9_MKKA1,    "JP", "JAPAN38",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN39,     MKK9_MKKC,     "JP", "JAPAN39",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN40,     MKK9_MKKA2,    "JP", "JAPAN40",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN41,     MKK10_FCCA,    "JP", "JAPAN41",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN42,     MKK10_MKKA1,   "JP", "JAPAN42",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN43,     MKK10_MKKC,    "JP", "JAPAN43",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN44,     MKK10_MKKA2,   "JP", "JAPAN44",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN45,     MKK11_MKKA,    "JP", "JAPAN45",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN46,     MKK11_FCCA,    "JP", "JAPAN46",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN47,     MKK11_MKKA1,   "JP", "JAPAN47",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN48,     MKK11_MKKC,    "JP", "JAPAN48",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN49,     MKK11_MKKA2,   "JP", "JAPAN49",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN50,     MKK12_MKKA,    "JP", "JAPAN50",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN51,     MKK12_FCCA,    "JP", "JAPAN51",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN52,     MKK12_MKKA1,   "JP", "JAPAN52",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN53,     MKK12_MKKC,    "JP", "JAPAN53",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN54,     MKK12_MKKA2,   "JP", "JAPAN54",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
/*    {CTRY_JAPAN55,     MKK5_MKKA,     "JP", "JAPAN55",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },*/
/*    {CTRY_JAPAN56,     MKK5_FCCA,     "JP", "JAPAN56",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },*/
    {CTRY_JAPAN57,     MKK13_MKKB,    "JP", "JAPAN57",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN58,     MKK14_MKKA1,   "JP", "JAPAN58",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JAPAN59,     MKK15_MKKA1,   "JP", "JAPAN59",        YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_JORDAN,      ETSI2_WORLD,   "JO", "JORDAN",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_KAZAKHSTAN,  NULL1_WORLD,   "KZ", "KAZAKHSTAN",     YES,  NO, YES, YES, YES,  NO,  NO, 7000 },
    {CTRY_KENYA,       APL1_WORLD,    "KE", "KENYA",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_KOREA_NORTH, APL9_WORLD,    "KP", "NORTH KOREA",    YES,  NO,  NO, YES,  NO, YES,  NO, 7000 },
    {CTRY_KOREA_ROC,   APL10_WORLD,   "KR", "KOREA REPUBLIC", YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    /* KOREA REPUBLIC3 */
    {CTRY_KOREA_ROC3,  APL9_WORLD,    "KR", "KOREA REPUBLIC", YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_KUWAIT,      ETSI3_WORLD,   "KW", "KUWAIT",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_LATVIA,      ETSI1_WORLD,   "LV", "LATVIA",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_LEBANON,     APL1_WORLD,    "LB", "LEBANON",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_LIECHTENSTEIN, ETSI1_WORLD, "LI", "LIECHTENSTEIN",  YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_LITHUANIA,   ETSI1_WORLD,   "LT", "LITHUANIA",      YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_LUXEMBOURG,  ETSI1_WORLD,   "LU", "LUXEMBOURG",     YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_MACAU,       FCC2_WORLD,    "MO", "MACAU SAR",      YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_MACEDONIA,   ETSI1_WORLD,   "MK", "MACEDONIA, FYRO", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_MALAYSIA,    FCC1_WORLD,    "MY", "MALAYSIA",       YES,  NO,  NO, YES, YES, YES, YES, 7000 },
    {CTRY_MALTA,       ETSI1_WORLD,   "MT", "MALTA",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
/* Add manually, Code:480 ,Mauritius */
    {CTRY_MAURITIUS, DEF_REGDMN, "MU", "MAURITIUS", YES, YES, YES, YES, YES, YES, YES, 7000},    
    {CTRY_MEXICO,      FCC1_FCCA,     "MX", "MEXICO",         YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_MONACO,      ETSI4_WORLD,   "MC", "MONACO",         YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_MOROCCO,     APL4_WORLD,    "MA", "MOROCCO",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_NEPAL,       APL1_WORLD,    "NP", "NEPAL",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_NETHERLANDS, ETSI1_WORLD,   "NL", "NETHERLANDS",    YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_NETHERLANDS_ANTILLES, ETSI1_WORLD, "AN", "NETHERLANDS ANTILLES", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_NEW_ZEALAND, FCC3_ETSIC,          "NZ", "NEW ZEALAND",    YES,  NO, YES, YES, YES, YES, YES, 7000 },
/* Add manually, Code:558 ,Nicaragua */
    {CTRY_NICARAGUA, DEF_REGDMN, "NI", "NICARAGUA", YES, YES, YES, YES, YES, YES, YES, 7000},   
    {CTRY_NORWAY,      ETSI1_WORLD,   "NO", "NORWAY",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_OMAN,        FCC3_WORLD,    "OM", "OMAN",           YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_PAKISTAN,    APL1_WORLD,    "PK", "PAKISTAN",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_PANAMA,      FCC1_FCCA,     "PA", "PANAMA",         YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_PAPUA_NEW_GUINEA, FCC1_WORLD, "PG", "PAPUA NEW GUINEA", YES, YES, YES, YES, YES, YES, YES, 7000 },
/* Add manually, Code:600 ,Paraguay */
    {CTRY_PARAGUAY, DEF_REGDMN, "PY", "PARAGUAY", YES, YES, YES, YES, YES, YES, YES, 7000},   
    {CTRY_PERU,        FCC3_WORLD,    "PE", "PERU",           YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_PHILIPPINES, FCC3_WORLD,    "PH", "PHILIPPINES",    YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_POLAND,      ETSI1_WORLD,   "PL", "POLAND",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_PORTUGAL,    ETSI1_WORLD,   "PT", "PORTUGAL",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_PUERTO_RICO, FCC1_FCCA,     "PR", "PUERTO RICO",    YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_QATAR,       APL1_WORLD,    "QA", "QATAR",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_ROMANIA,     ETSI1_WORLD,   "RO", "ROMANIA",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_RUSSIA,      ETSI8_WORLD,   "RU", "RUSSIA",         YES,  NO, NO,  YES, YES, YES, YES, 7000 },
    {CTRY_RWANDA,      APL1_WORLD,    "RW", "RWANDA",         YES,  NO, YES, YES, YES, YES,  YES, 7000 },
    {CTRY_SAUDI_ARABIA, FCC2_WORLD,   "SA", "SAUDI ARABIA",   YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_SERBIA,      ETSI1_WORLD,   "RS", "REPUBLIC OF SERBIA", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_MONTENEGRO,  ETSI1_WORLD,   "ME", "MONTENEGRO",     YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SINGAPORE,   APL6_WORLD,    "SG", "SINGAPORE",      YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SLOVAKIA,    ETSI1_WORLD,   "SK", "SLOVAKIA",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SLOVENIA,    ETSI1_WORLD,   "SI", "SLOVENIA",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SOUTH_AFRICA, FCC3_WORLD,   "ZA", "SOUTH AFRICA",   YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SPAIN,       ETSI1_WORLD,   "ES", "SPAIN",          YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SRI_LANKA,   FCC3_WORLD,    "LK", "SRI LANKA",      YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_SWEDEN,      ETSI1_WORLD,   "SE", "SWEDEN",         YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SWITZERLAND, ETSI1_WORLD,   "CH", "SWITZERLAND",    YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_SYRIA,       NULL1_WORLD,   "SY", "SYRIAN ARAB REPUBLIC", YES,  NO, YES, YES, YES,  NO,  NO, 7000 },
    {CTRY_TAIWAN,      APL7_FCCA,     "TW", "TAIWAN",         YES, YES, YES, YES, YES, YES, YES, 7000 },
    /* Add manually, Code:834 ,Tanzania */
    {CTRY_TANZANIA, DEF_REGDMN, "TZ", "TANZANIA", YES, YES, YES, YES, YES, YES, YES, 7000},  
    {CTRY_THAILAND,    FCC3_WORLD,    "TH", "THAILAND",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_TRINIDAD_Y_TOBAGO, FCC3_WORLD, "TT", "TRINIDAD AND TOBAGO", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_TUNISIA,     ETSI3_WORLD,   "TN", "TUNISIA",        YES,  NO, YES, YES, YES, YES,  NO, 7000 },
    {CTRY_TURKEY,      ETSI3_WORLD,   "TR", "TURKEY",         YES,  NO, YES, YES, YES, YES,  NO, 7000 },
/* Add manually, Code:800 ,Uganda */
    {CTRY_UGANDA, DEF_REGDMN, "UG", "UGANDA", YES, YES, YES, YES, YES, YES, YES, 7000},     
    {CTRY_UKRAINE,     ETSI9_WORLD,   "UA", "UKRAINE",        YES,  NO, NO,  YES, YES, YES,  YES, 7000 },
    {CTRY_UAE,         ETSI1_WORLD, "AE", "UNITED ARAB EMIRATES", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_UNITED_KINGDOM, ETSI1_WORLD, "GB", "UNITED KINGDOM", YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_UNITED_STATES, FCC3_FCCA,   "US", "UNITED STATES",  YES, YES, YES, YES, YES, YES, YES, 5825 },
    /* UNITED STATES2 */
    {CTRY_UNITED_STATES2, FCC6_FCCA,  "US", "UNITED STATES",  YES, YES, YES, YES, YES, YES, YES, 7000 }, 
    {CTRY_UNITED_STATES_FCC49, FCC4_FCCA,   "PS", "UNITED STATES (PUBLIC SAFETY)",  YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_URUGUAY,     FCC3_WORLD,    "UY", "URUGUAY",        YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_UZBEKISTAN,  FCC3_FCCA,     "UZ", "UZBEKISTAN",     YES, YES, YES, YES, YES, YES, YES, 7000 },
    {CTRY_VENEZUELA,   FCC1_WORLD,    "VE", "VENEZUELA",      YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_VIET_NAM,    ETSI3_WORLD,   "VN", "VIET NAM",       YES,  NO, YES, YES, YES, YES, YES, 7000 },
    {CTRY_YEMEN,       NULL1_WORLD,   "YE", "YEMEN",          YES,  NO, YES, YES, YES,  NO,  NO, 7000 },
    {CTRY_ZIMBABWE,    NULL1_WORLD,   "ZW", "ZIMBABWE",       YES,  NO, YES, YES, YES,  NO,  NO, 7000 }
};

#endif
