/*
 * We define some common data struction here
 * Rugemeng 20131203
 */
 
#ifndef __COMMON_H__
#define __COMMON_H__

typedef unsigned char u_int8_t;
typedef unsigned short u_int16_t;
typedef unsigned int  u_int32_t;

typedef signed char INT8;
typedef unsigned char 	UINT8;
typedef unsigned short	UINT16;
typedef unsigned int 	UINT32;

typedef unsigned char BOOLEAN;

typedef u_int16_t HAL_CTRY_CODE;        /* country code */
typedef u_int16_t HAL_REG_DOMAIN;       /* regulatory domain code */

typedef HAL_CTRY_CODE CTRY_CODE;		/* country code */

#define IEEE80211_CHAN_TURBO            0x00010 /* Turbo channel */
#define IEEE80211_CHAN_CCK               0x00020 /* CCK channel */
#define IEEE80211_CHAN_OFDM             0x00040 /* OFDM channel */
#define IEEE80211_CHAN_2GHZ            0x00080 /* 2 GHz spectrum channel. */
#define IEEE80211_CHAN_5GHZ             0x00100 /* 5 GHz spectrum channel */
#define IEEE80211_CHAN_PASSIVE          0x00200 /* Only passive scan allowed */
#define IEEE80211_CHAN_DYN              0x00400 /* Dynamic CCK-OFDM channel */
#define IEEE80211_CHAN_GFSK             0x00800 /* GFSK channel (FHSS PHY) */
#define IEEE80211_CHAN_RADAR            0x01000 /* Radar found on channel */
#define IEEE80211_CHAN_STURBO           0x02000 /* 11a static turbo channel only */
#define IEEE80211_CHAN_HALF             0x04000 /* Half rate channel */
#define IEEE80211_CHAN_QUARTER          0x08000 /* Quarter rate channel */
#define IEEE80211_CHAN_HT20             0x10000 /* HT 20 channel */
#define IEEE80211_CHAN_HT40PLUS         0x20000 /* HT 40 with extension channel above */
#define IEEE80211_CHAN_HT40MINUS        0x40000 /* HT 40 with extension channel below */
#define IEEE80211_CHAN_HT40INTOL        0x80000 /* HT 40 Intolerant */

#define IEEE80211_CHAN_DFS              0x0002   /* DFS required on channel */
#define IEEE80211_CHAN_DFS_CLEAR        0x0008  /* if channel has been checked for DFS */
#define IEEE80211_CHAN_11D_EXCLUDED     0x0010  /* excluded in 11D */
#define IEEE80211_CHAN_CSA_RECEIVED     0x0020  /* Channel Switch Announcement received on this channel */
#define IEEE80211_CHAN_DISALLOW_ADHOC   0x0040  /* ad-hoc is not allowed */
#define IEEE80211_CHAN_DISALLOW_HOSTAP  0x0080  /* Station only channel */

#endif
