/*
 * This file is Format from AP.....csv
 * We must take more attention to this file's Region Domain
 * 
 * Rugemeng 20131203 
*/
#ifndef __COUNTRY_REGION_H__
#define __COUNTRY_REGION_H__
#include "common.h"
#include "regulatory_domain.h"
typedef struct {
	HAL_CTRY_CODE countryCode;
	HAL_REG_DOMAIN regDmnEnum;
}COUNTRY_AUTH;

/* For some country have more than one country code, we only ues one
  * We don't have the product for Japan, so ignore its mutil country code
  */
#define ALL_COUNTRY 0
#define DEBUG_COUNTRY 0

static const COUNTRY_AUTH allCountryAuto[] = {
#if DEBUG_COUNTRY
	{CTRY_DEBUG,NO_ENUMRD},
	{CTRY_DEFAULT,DEF_REGDMN},
#endif
	{CTRY_ALBANIA,NULL1_WORLD},
	{CTRY_ALGERIA,NULL1_WORLD},
	{CTRY_ARGENTINA,FCC3_WORLD},
	{CTRY_ARMENIA,ETSI4_WORLD},
	{CTRY_ARUBA,ETSI1_WORLD},
	{CTRY_AUSTRALIA,FCC3_WORLD},
#if ALL_COUNTRY
	{CTRY_AUSTRALIA2,FCC6_WORLD},
#endif
	{CTRY_AUSTRIA,ETSI1_WORLD},
	{CTRY_AZERBAIJAN,ETSI4_WORLD},
	{CTRY_BAHAMAS,FCC3_WORLD},
	{CTRY_BAHRAIN,APL6_WORLD},
	{CTRY_BANGLADESH,NULL1_WORLD},
	{CTRY_BARBADOS,FCC2_WORLD},
	{CTRY_BELARUS,ETSI1_WORLD},
	{CTRY_BELGIUM,ETSI1_WORLD},
#if ALL_COUNTRY
	{CTRY_BELGIUM2,ETSI4_WORLD},
#endif
	{CTRY_BELIZE,APL1_ETSIC},
	{CTRY_BERMUDA,FCC3_FCCA},
	{CTRY_BOLIVIA,APL1_ETSIC},
	{CTRY_BOSNIA_HERZ,ETSI1_WORLD},
	{CTRY_BRAZIL,FCC3_WORLD},
	{CTRY_BRUNEI_DARUSSALAM,APL6_WORLD},
	{CTRY_BULGARIA,ETSI1_WORLD},
	{CTRY_CAMBODIA,ETSI1_WORLD},
	{CTRY_CANADA,FCC3_FCCA},
#if ALL_COUNTRY
	{CTRY_CANADA2,FCC6_FCC},
#endif
	{CTRY_CHILE,APL6_WORL},
	{CTRY_CHINA,APL1_WORL},
	{CTRY_COLOMBIA,FCC1_FCCA},
	{CTRY_COSTA_RICA,FCC1_WORLD},
	{CTRY_CROATIA,ETSI1_WORLD},
	{CTRY_CYPRUS,ETSI1_WORLD},
	{CTRY_CZECH,ETSI1_WORLD},
	{CTRY_DENMARK,ETSI1_WORLD},
	{CTRY_DOMINICAN_REPUBLIC,FCC1_FCCA},
	{CTRY_ECUADOR,FCC1_WORLD},
	{CTRY_EGYPT,ETSI3_WORLD},
	{CTRY_EL_SALVADOR,FCC1_WORLD},
	{CTRY_ESTONIA,ETSI1_WORLD},
	{CTRY_FINLAND,ETSI1_WORLD},
	{CTRY_FRANCE,ETSI1_WORLD},
	{CTRY_GEORGIA,ETSI4_WORLD},
	{CTRY_GERMANY,ETSI1_WORLD},
	{CTRY_GREECE,ETSI1_WORL},
	{CTRY_GREENLAND,ETSI1_WORLD},
	{CTRY_GRENADA,FCC3_FCCA},
	{CTRY_GUAM,FCC1_FCCA},
	{CTRY_GUATEMALA,FCC1_FCCA},
	{CTRY_HAITI,ETSI1_WORLD},
	{CTRY_HONDURAS,FCC3_WORLD},
	{CTRY_HONG_KONG,FCC3_WORLD},
	{CTRY_HUNGARY,ETSI1_WORLD},
	{CTRY_ICELAND,ETSI1_WORLD},
	{CTRY_INDIA,APL6_WORLD},
	{CTRY_INDONESIA,APL2_WORLD},
	{CTRY_IRAN,APL1_WORLD},
	{CTRY_IRELAND,ETSI1_WORLD},
	{CTRY_ISRAEL,ETSI3_WORLD},
	{CTRY_ITALY,ETSI1_WORLD},
	{CTRY_JAMAICA,FCC3_WORLD},
	{CTRY_JAPAN,MKK1_MKKA},
#if ALL_COUNTRY
	{CTRY_JAPAN1,MKK1_MKKB},
	{CTRY_JAPAN2,MKK1_FCCA},
	{CTRY_JAPAN3,MKK2_MKKA},
	{CTRY_JAPAN4,MKK1_MKKA1},
	{CTRY_JAPAN5,MKK1_MKKA2},
	{CTRY_JAPAN6,MKK1_MKKC},
	{CTRY_JAPAN7,MKK3_MKKB},
	{CTRY_JAPAN8,MKK3_MKKA2},
	{CTRY_JAPAN9,MKK3_MKKC},
	{CTRY_JAPAN10,MKK4_MKKB},
	{CTRY_JAPAN11,MKK4_MKKA2},
	{CTRY_JAPAN12,MKK4_MKKC},
	{CTRY_JAPAN13,MKK5_MKKB},
	{CTRY_JAPAN14,MKK5_MKKA2},
	{CTRY_JAPAN15,MKK5_MKKC},
	{CTRY_JAPAN16,MKK6_MKKB},
	{CTRY_JAPAN17,MKK6_MKKA2},
	{CTRY_JAPAN18,MKK6_MKKC},
	{CTRY_JAPAN19,MKK7_MKKB},
	{CTRY_JAPAN20,MKK7_MKKA2},
	{CTRY_JAPAN21,MKK7_MKKC},
	{CTRY_JAPAN22,MKK8_MKKB},
	{CTRY_JAPAN23,MKK8_MKKA2},
	{CTRY_JAPAN24,MKK8_MKKC},
	{CTRY_JAPAN25,MKK3_MKKA},
	{CTRY_JAPAN26,MKK3_MKKA1},
	{CTRY_JAPAN27,MKK3_FCCA},
	{CTRY_JAPAN28,MKK4_MKKA1},
	{CTRY_JAPAN29,MKK4_FCCA},
	{CTRY_JAPAN30,MKK6_MKKA1},
	{CTRY_JAPAN31,MKK6_FCCA},
	{CTRY_JAPAN32,MKK7_MKKA1},
	{CTRY_JAPAN33,MKK7_FCCA},
	{CTRY_JAPAN34,MKK9_MKKA},
	{CTRY_JAPAN35,MKK10_MKKA},
	{CTRY_JAPAN36,MKK4_MKKA},
	{CTRY_JAPAN37,MKK9_FCCA},
	{CTRY_JAPAN38,MKK9_MKKA1},
	{CTRY_JAPAN39,MKK9_MKKC},
	{CTRY_JAPAN40,MKK9_MKKA2},
	{CTRY_JAPAN41,MKK10_FCCA},
	{CTRY_JAPAN42,MKK10_MKKA1},
	{CTRY_JAPAN43,MKK10_MKKC},
	{CTRY_JAPAN44,MKK10_MKKA2},
	{CTRY_JAPAN45,MKK11_MKKA},
	{CTRY_JAPAN46,MKK11_FCCA},
	{CTRY_JAPAN47,MKK11_MKKA1},
	{CTRY_JAPAN48,MKK11_MKKC},
	{CTRY_JAPAN49,MKK11_MKKA2},
	{CTRY_JAPAN50,MKK12_MKKA},
	{CTRY_JAPAN51,MKK12_FCCA},
	{CTRY_JAPAN52,MKK12_MKKA1},
	{CTRY_JAPAN53,MKK12_MKKC},
	{CTRY_JAPAN54,MKK12_MKKA2},
	{CTRY_JAPAN55,MKK5_MKKA},
	{CTRY_JAPAN56,MKK5_FCCA},
	{CTRY_JAPAN57,MKK13_MKKB},
	{CTRY_JAPAN58,MKK14_MKKA1},
	{CTRY_JAPAN59,MKK15_MKKA1},
#endif
	{CTRY_JORDAN,ETSI2_WORLD},
	{CTRY_KAZAKHSTAN,ETSI_WORLD},
	{CTRY_KENYA,APL1_WORLD},
	{CTRY_KOREA_NORTH,APL9_WORLD},
#if ALL_COUNTRY
	{CTRY_KOREA_ROC,APL10_WORLD},
#endif
	{CTRY_KOREA_ROC3,APL9_WORLD},
	{CTRY_KUWAIT,ETSI3_WORLD},
	{CTRY_LATVIA,ETSI1_WORLD},
	{CTRY_LEBANON,APL1_WORLD},
	{CTRY_LIECHTENSTEIN,ETSI1_WORLD},
	{CTRY_LITHUANIA,ETSI1_WORLD},
	{CTRY_LUXEMBOURG,ETSI1_WORLD},
	{CTRY_MACAU,FCC2_WORLD},
	{CTRY_MACEDONIA,ETSI1_WORLD},
	{CTRY_MALAYSIA,FCC1_WORLD},
	{CTRY_MALTA,ETSI1_WORLD},
	{CTRY_MAURITIUS,ETSI1_WORLD},
	{CTRY_MEXICO,FCC1_WORLD},
	{CTRY_MONACO,ETSI4_WORLD},
	{CTRY_MOROCCO,APL4_WORLD},
	{CTRY_NEPAL,APL1_WORLD},
	{CTRY_NETHERLANDS,ETSI1_WORLD},
#if ALL_COUNTRY /* */
	{CTRY_NETHERLANDS_ANTILLES,},
#endif
	{CTRY_NEW_ZEALAND,FCC3_ETSIC},
	{CTRY_NICARAGUA,FCC3_FCCA},
	{CTRY_NORWAY,ETSI1_WORLD},
	{CTRY_OMAN,FCC3_WORLD},
	{CTRY_PAKISTAN,APL1_WORLD},
	{CTRY_PANAMA,FCC1_FCCA},
	{CTRY_PAPUA_NEW_GUINEA,FCC1_WORLD},
	{CTRY_PARAGUAY,FCC3_WORLD},
	{CTRY_PERU,FCC3_WORLD},
	{CTRY_PHILIPPINES,FCC3_WORLD},
	{CTRY_POLAND,ETSI1_WORLD},
	{CTRY_PORTUGAL,ETSI1_WORLD},
	{CTRY_PUERTO_RICO,FCC1_FCCA},
	{CTRY_QATAR,APL1_WORLD},
	{CTRY_ROMANIA,ETSI1_WORLD},
	{CTRY_RUSSIA,ETSI8_WORLD},
	{CTRY_RWANDA,APL1_WORLD},
	{CTRY_SAUDI_ARABIA,FCC2_WORLD},
	{CTRY_SERBIA,ETSI1_WORLD},
	{CTRY_MONTENEGRO,ETSI1_WORLD},
	{CTRY_SINGAPORE,FCC3_WORLD},
	{CTRY_SLOVAKIA,ETSI1_WORLD},
	{CTRY_SLOVENIA,ETSI1_WORLD},
	{CTRY_SOUTH_AFRICA,FCC3_WORLD},
	{CTRY_SPAIN,ETSI1_WORLD},
	{CTRY_SRI_LANKA,FCC3_WORLD},
	{CTRY_SWEDEN,ETSI1_WORLD},
	{CTRY_SWITZERLAND,ETSI1_WORLD},
	{CTRY_SYRIA,NULL1_WORLD},
	{CTRY_TAIWAN,APL7_FCCA},
	{CTRY_TANZANIA,APL1_WORLD},
	{CTRY_THAILAND,FCC3_WORLD},
	{CTRY_TRINIDAD_Y_TOBAGO,FCC3_WORLD},
	{CTRY_TUNISIA,ETSI3_WORLD},
	{CTRY_TURKEY,ETSI3_WORLD},
	{CTRY_UGANDA,APL10_WORLD},
	{CTRY_UKRAINE,ETSI9_WORLD},
	/*
	{CTRY_UGANDA,APL10_WORLD},
	*/
	{CTRY_UAE,ETSI1_WORLD},
	{CTRY_UNITED_KINGDOM,ETSI1_WORLD},
#if ALL_COUNTRY
	{CTRY_UNITED_STATES,FCC3_FCCA},
#endif
	{CTRY_UNITED_STATES2,FCC6_FCCA},
#if ALL_COUNTRY
	{CTRY_UNITED_STATES_FCC49,FCC4_FCCA},
#endif
	{CTRY_URUGUAY,FCC3_WORLD},
	{CTRY_UZBEKISTAN,FCC3_FCCA},
	{CTRY_VENEZUELA,FCC1_WORLD},
	{CTRY_VIET_NAM,ETSI3_WORLD},
	{CTRY_YEMEN,NULL1_WORLD},
	{CTRY_ZIMBABWE,NULL1_WORLD},
};

#endif
