/* 
  * Country Code information For TL-WA3500RE V1 and RE210 V1
  * Rugemeng  20131203
  *
  */

#ifndef __LOCAL_H__
#define __LOCAL_H__

#include "common.h"
#include "countryCode.h"
#include "CountryName.h"
#include "country_region.h"
/* 
 * This info we can fix it to adapt the tech
 *
 */
 
 #define COUNTRY_NUM		200

#define CHANNEL_2G_NUM	    15
#define CHANNEL_2G_INT	    5
#define CHANNEL_2G_FREQ_START 2412
#define CHANNEL_2G_FREQ_STOP  2412 + 5 * 12
#define CHANNEL_2G_FREQ_14	2484

#define CHANNEL_5G_NUM	    30
#define CHANNEL_5G_INT	    20
#define CHANNEL_5G_FREQ_START		5180
#define CHANNEL_5G_FREQ_STOP		5900
#define CHANNEL_5G_BAND1_START 	5180
#define CHANNEL_5G_BAND1_STOP  	5240
#define CHANNEL_5G_BAND2_START 	5260
#define CHANNEL_5G_BAND2_STOP  	5320
#define CHANNEL_5G_BAND3_START 	5500
#define CHANNEL_5G_BAND3_STOP  	5700
#define CHANNEL_5G_BAND4_START 	5745
#define CHANNEL_5G_BAND4_STOP  	5825
#define CHANNEL_5G_BAND1_NUM_START	36
#define CHANNEL_5G_BAND1_NUM_STOP 	48
#define CHANNEL_5G_BAND2_NUM_START	52
#define CHANNEL_5G_BAND2_NUM_STOP 	64
#define CHANNEL_5G_BAND3_NUM_START	100
#define CHANNEL_5G_BAND3_NUM_STOP 	140
#define CHANNEL_5G_BAND4_NUM_START	149
#define CHANNEL_5G_BAND4_NUM_STOP 	165


/* end fix info */
typedef enum _BAND {
	BAND_2G = 0,
	BAND_5G = 1,
}BAND;

typedef struct _CHANNEL_INFO {
    UINT16 support;
    u_int16_t maxTxPower;
    u_int32_t flag;
    u_int32_t extFlag;
    UINT8 Geography;			/* Use in Ralink, 0:out door, 1:in door, 2:both */
    BOOLEAN DfsReq;			/* Use in Ralink, Dfs require, 0: No, 1: yes. */
   UINT32 atherosFlag;
}ChannelInfo;
#define INDEX_2G_CHANNEL_FREQ(ch)  ({ \
	int ret = -1; \
	if ( ch >= CHANNEL_2G_FREQ_START && ch <= CHANNEL_2G_FREQ_STOP ) \
            ret = (ch -CHANNEL_2G_FREQ_START)%CHANNEL_2G_INT? -1 : ((ch - CHANNEL_2G_FREQ_START)/5); \
	else if ( ch == CHANNEL_2G_FREQ_14 ) \
	    ret = 13; \
	ret; \
	})

#define INDEX_5G_CHANNEL_FREQ(ch) ({ \
	int ret = -1; \
	if ( ch <= CHANNEL_5G_BAND1_STOP && ch >= CHANNEL_5G_BAND1_START ) \
	    ret = (ch-CHANNEL_5G_BAND1_START)%CHANNEL_5G_INT?-1:((ch-CHANNEL_5G_BAND1_START)/20); \
	else if ( ch <= CHANNEL_5G_BAND2_STOP && ch >= CHANNEL_5G_BAND2_START )\
	    ret = (ch-CHANNEL_5G_BAND2_START)%CHANNEL_5G_INT?-1:((ch-CHANNEL_5G_BAND2_START)/20 + 4); \
	else if ( ch <= CHANNEL_5G_BAND3_STOP && ch >= CHANNEL_5G_BAND3_START )\
	    ret = (ch-CHANNEL_5G_BAND3_START)%CHANNEL_5G_INT?-1:((ch-CHANNEL_5G_BAND3_START)/20 + 8); \
	else if ( ch <= CHANNEL_5G_BAND4_STOP && ch >= CHANNEL_5G_BAND4_START )\
	    ret = (ch-CHANNEL_5G_BAND4_START)%CHANNEL_5G_INT?-1:((ch-CHANNEL_5G_BAND4_START)/20 + 19); \
	 ret; \
	})

#define INDEX_2G_CHANNEL_NUM(ch) ({ \
	int ret = -1; \
	if ( ch < 0 || ch >= CHANNEL_2G_NUM ) \
		ret = -1; \
	else \
		ret = ch-1; \
	ret;\
	})

#define INDEX_5G_CHANNEL_NUM(ch) ({ \
	int ret = -1; \
	if ( ch <= CHANNEL_5G_BAND2_NUM_STOP && ch >= CHANNEL_5G_BAND1_NUM_START ) \
	    ret = (ch-CHANNEL_5G_BAND1_NUM_START)%4?-1:((ch-CHANNEL_5G_BAND1_NUM_START)/4); \
	else if ( ch <= CHANNEL_5G_BAND3_NUM_STOP && ch >= CHANNEL_5G_BAND3_NUM_START )\
	    ret = (ch-CHANNEL_5G_BAND3_NUM_START)%4?-1:((ch-CHANNEL_5G_BAND3_NUM_START)/4 + 8); \
	else if ( ch <= CHANNEL_5G_BAND4_NUM_STOP && ch >= CHANNEL_5G_BAND4_NUM_START )\
	    ret = (ch-CHANNEL_5G_BAND4_NUM_START)%4?-1:((ch-CHANNEL_5G_BAND4_NUM_START)/4 + 19); \
	 ret; \
	})

#define INDEX_2G_TO_CHANNEL(index) ({ \
	int ret = -1; \
	if (index <0 && index >= CHANNEL_2G_NUM ) \
		ret = -1; \
	else \
		ret = index+1; \
	ret; \
	})
	
#define INDEX_5G_TO_CHANNEL(index) ({ \
	int ret = -1;	\
	if (index <0 && index >= CHANNEL_5G_NUM -1 )	\
		ret = -1;	\
	else if (index < 8)	\
		ret = index * 4 + 36;	\
	else if (index < 19 )	\
		ret = (index -8) * 4 + 100;	\
	else 	\
		ret = (index - 19) *4 + 149;	\
	ret ;	\
	})



typedef struct _COUNTRY_INFO {
    CTRY_CODE	countryCode;
    char isoName[3];
    char name[40];			/* UNITED STATES */
    char nameL[40];		/* United States */
	UINT16	region;
    UINT16 
	allow24Gh:	1,
	allow5Gh:	1,
	allow11AC:	1,
	allow11nht20:	1,
	allow11nht40:	1,
	allow11aht20:	1,
	allow11aht40:	1,
	allowaband1:	1,
	allowaband2:	1,
	allowaband3:	1,
	allowaband4:	1;
    ChannelInfo channelInfo2G[CHANNEL_2G_NUM];
	UINT32 ch2GBit;
    ChannelInfo channelInfo5G[CHANNEL_5G_NUM];
	UINT32 ch5GBit;
     
	
}CountryInfo;
#define BITALL		0xffffffff
#define BITALLOW24GH	0x01
#define BITALLOW5GH	0x02
#define BITALLOW11AC	0x04
#define BITALLOW11NHT20 0x08
#define BITALLOW11NHT40	0x010
#define BITALLOW11AHT20 0x020
#define BITALLOW11AHT40 0x040
#define BITALLOW11ABAND1 0x080
#define BITALLOW11ABAND2 0x0100
#define BITALLOW11ABAND3 0x0200
#define BITALLOW11ABAND4 0x0400

#define TEST24G(x)  (x).allow24Gh == 1 
#define SET24G(x)   (x).allow24Gh = 1
#define CLR24G(x)   (x).allow24Gh = 0

#define TEST5G(x)  (x).allow5Gh == 1
#define SET5G(x)   (x).allow5Gh = 1
#define CLR5G(x)   (x).allow5Gh = 0

#define TEST11AC(x)  (x).allow11AC == 1
#define SET11AC(x)   (x).allow11AC = 1
#define CLR11AC(x)   (x).allow11AC = 0

#define TEST11ABAND1(x)	(x).allowaband1 == 1
#define SET11ABAND1(x)	(x).allowaband1 = 1

#define TEST11ABAND2(x)	(x).allowaband2 == 1
#define SET11ABAND2(x)	(x).allowaband2 = 1

#define TEST11ABAND3(x)	(x).allowaband3 == 1
#define SET11ABAND3(x)	(x).allowaband3 = 1

#define TEST11ABAND4(x)	(x).allowaband4 == 1
#define SET11ABAND4(x)	(x).allowaband4 = 1

#define A_BAND1_BIT				0x0000000f		/* band1, ch:36-48 	*/
#define A_BAND2_BIT				0x000000f0		/* band2, ch:52-64	*/
#define A_BAND2_2_BIT			0x000000e0		/* band2_1, ch:56-64	*/
#define A_BAND3_BIT				0x0007ff00		/* band3, ch:100-140*/
#define A_BAND3_1_BIT			0x00071f00		/* band3_1,ch:100-116,132-140*/
#define A_BAND3_2_BIT			0x00007f00		/* band3_2,ch:100-124 */
#define A_BAND3_3_BIT			0x00070000		/* band3_3,ch:132-140 */
#define A_BAND3_4_BIT			0x0001ff00		/* band3_4,ch:100-132 */
#define A_BAND4_BIT				0x00f80000		/* band4, ch:149-165*/
#define A_BAND4_1_BIT			0x00780000		/* band4_1,ch:149-161*/

#define A_BAND_KP				0x00787fff		/* NORTH KOREA, 36-48,52-64,100-124,149-161 */
#define A_BAND_KR1				0x007fffff		/* KOREA 1, 36-48, 52-64, 100-140, 149-161 */
#define A_BAND_KR2				0x00787fff		/* KOREA 1, 36-48, 52-64, 100-124, 149-161 */
#define A_BAND_RU				0x007f00ff		/* RUSSIA, 36-48, 52-64, 132-140, 149-161 */
#define A_BAND_SY				0x00ff1fe0		/* SYRIAN, 56-64, 100-116, 132-140, 149-165 */
#define A_BAND_TW				A_BAND_SY
#define A_BAND_UA				0x00f9ffff		/* UKRAINE, 36-48, 52-64, 100-132 149-165 */

#define REGION_FCC		1
#define REGION_CE		2
#define REGION_OTHER	3
#define REGION_NULL		0

#define  FILE2G 	"country_2g_all.log"
#define  FILE5G 	"country_5g_all.log"


#if 1  /* */
#define IEEE80211_CHAN_TURBO            	0x00010 /* Turbo channel */
#define IEEE80211_CHAN_CCK               	0x00020 /* CCK channel */
#define IEEE80211_CHAN_OFDM             	0x00040 /* OFDM channel */
#define IEEE80211_CHAN_2GHZ            		0x00080 /* 2 GHz spectrum channel. */
#define IEEE80211_CHAN_5GHZ             	0x00100 /* 5 GHz spectrum channel */
#define IEEE80211_CHAN_PASSIVE          	0x00200 /* Only passive scan allowed */
#define IEEE80211_CHAN_DYN              		0x00400 /* Dynamic CCK-OFDM channel */
#define IEEE80211_CHAN_GFSK             	0x00800 /* GFSK channel (FHSS PHY) */
#define IEEE80211_CHAN_RADAR            	0x01000 /* Radar found on channel */
#define IEEE80211_CHAN_STURBO          	0x02000 /* 11a static turbo channel only */
#define IEEE80211_CHAN_HALF             	0x04000 /* Half rate channel */
#define IEEE80211_CHAN_QUARTER          	0x08000 /* Quarter rate channel */
#define IEEE80211_CHAN_HT20             	0x10000 /* HT 20 channel */
#define IEEE80211_CHAN_HT40PLUS         	0x20000 /* HT 40 with extension channel above */
#define IEEE80211_CHAN_HT40MINUS        	0x40000 /* HT 40 with extension channel below */
#define IEEE80211_CHAN_HT40INTOL        	0x80000 /* HT 40 Intolerant */

#define IEEE80211_CHAN_DFS              			0x0002   /* DFS required on channel */
#define IEEE80211_CHAN_DFS_CLEAR        		0x0008  /* if channel has been checked for DFS */
#define IEEE80211_CHAN_11D_EXCLUDED     	0x0010  /* excluded in 11D */
#define IEEE80211_CHAN_CSA_RECEIVED     	0x0020  /* Channel Switch Announcement received on this channel */
#define IEEE80211_CHAN_DISALLOW_ADHOC   	0x0040  /* ad-hoc is not allowed */
#define IEEE80211_CHAN_DISALLOW_HOSTAP  	0x0080  /* Station only channel */
#endif

#define    IEEE80211_ATHEROS_WEB_FLAG_AUTO             1<<0    /* autoselect */
#define    IEEE80211_ATHEROS_WEB_FLAG_11A              1<<1    /* 5GHz; OFDM */
#define    IEEE80211_ATHEROS_WEB_FLAG_11B              1<<2    /* 2GHz, CCK */
#define    IEEE80211_ATHEROS_WEB_FLAG_11G              1<<3    /* 2GHz, OFDM */
#define    IEEE80211_ATHEROS_WEB_FLAG_FH               1<<4    /* 2GHz, GFSK */
#define    IEEE80211_ATHEROS_WEB_FLAG_TURBO_A          1<<5    /* 5GHz, OFDM, 2x clock dynamic turbo */
#define    IEEE80211_ATHEROS_WEB_FLAG_TURBO_G          1<<6    /* 2GHz, OFDM, 2x clock  dynamic turbo*/
#define    IEEE80211_ATHEROS_WEB_FLAG_11NA_HT20        1<<7    /* 5Ghz, HT20 */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NG_HT20        1<<8    /* 2Ghz, HT20 */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NA_HT40PLUS    1<<9    /* 5Ghz, HT40 (ext ch +1) */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NA_HT40MINUS   1<<10   /* 5Ghz, HT40 (ext ch -1) */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NG_HT40PLUS    1<<11   /* 2Ghz, HT40 (ext ch +1) */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NG_HT40MINUS   1<<12   /* 2Ghz, HT40 (ext ch -1) */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NG_HT40        1<<13   /* 2Ghz, Auto HT40 */
#define    IEEE80211_ATHEROS_WEB_FLAG_11NA_HT40        1<<14   /* 5Ghz, Auto HT40 */
#define	 IEEE80211_ATHEROS_WEB_FLAG_DFS	   1<<15   /* DFS channel */

 #define LOCAL_TO_ATHEROS_FLAG(flag, extflag)	({	\
 	u_int32_t		newFlag = 0;	\
 	if ( flag & IEEE80211_CHAN_5GHZ)	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11A; \
	if ( flag & IEEE80211_CHAN_CCK)	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11B; \
	if ( flag & IEEE80211_CHAN_2GHZ)	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11G; \
	if ( flag & IEEE80211_CHAN_GFSK)	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_FH; \
	if ( flag & IEEE80211_CHAN_5GHZ)	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NA_HT20; \
	if ( flag & IEEE80211_CHAN_2GHZ)	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NG_HT20; \
	if (( flag & IEEE80211_CHAN_HT40PLUS) && (flag & IEEE80211_CHAN_5GHZ))	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NA_HT40PLUS; \
	if (( flag & IEEE80211_CHAN_HT40MINUS) && (flag & IEEE80211_CHAN_5GHZ))	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NA_HT40MINUS; \
	if (( flag & IEEE80211_CHAN_HT40PLUS) && (flag & IEEE80211_CHAN_2GHZ))	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NG_HT40PLUS; \
	if (( flag & IEEE80211_CHAN_HT40MINUS) && (flag & IEEE80211_CHAN_2GHZ))	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NG_HT40MINUS; \
	if (( flag & (IEEE80211_CHAN_HT40MINUS | IEEE80211_CHAN_HT40PLUS)) && (flag & IEEE80211_CHAN_2GHZ))	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NG_HT40; \
	if (( flag & (IEEE80211_CHAN_HT40MINUS | IEEE80211_CHAN_HT40PLUS )) && (flag & IEEE80211_CHAN_5GHZ))	newFlag |= IEEE80211_ATHEROS_WEB_FLAG_11NA_HT40; \
	if ( extflag & IEEE80211_CHAN_DFS)		newFlag |= IEEE80211_ATHEROS_WEB_FLAG_DFS; \
	newFlag ; \
 })

#if 0
#define PRINT printf
#else
#define PRINT
#endif

#endif
