/* 
  * Country Code information For TL-WA3500RE V1 and RE210 V1
  * Rugemeng  20131203
  *
  */

#ifndef __RALINK_DESCP_FORMAT_H__
#define __RALINK_DESCP_FORMAT_H__

#include "rt_channel.h"

#define DEFINERALINKDESCP(abbr)	__attribute__((weak)) CH_DESP Country_##abbr##_ChDesp[] = {{0},};
#define RALINKDESCP(abbr) Country_##abbr##_ChDesp

#define GETDESCP(isoname)	({ \
CH_DESP *tmpDesp = NULL; \
switch(isoname[0] * 64 + isoname[1]) { \
case 'D'*64 + 'B': tmpDesp = RALINKDESCP(DB);break;\
case 'N'*64 + 'A': tmpDesp = RALINKDESCP(NA);break;\
case 'A'*64 + 'L': tmpDesp = RALINKDESCP(AL);break;\
case 'D'*64 + 'Z': tmpDesp = RALINKDESCP(DZ);break;\
case 'A'*64 + 'R': tmpDesp = RALINKDESCP(AR);break;\
case 'A'*64 + 'M': tmpDesp = RALINKDESCP(AM);break;\
case 'A'*64 + 'W': tmpDesp = RALINKDESCP(AW);break;\
case 'A'*64 + 'U': tmpDesp = RALINKDESCP(AU);break;\
case 'A'*64 + 'T': tmpDesp = RALINKDESCP(AT);break;\
case 'A'*64 + 'Z': tmpDesp = RALINKDESCP(AZ);break;\
case 'B'*64 + 'S': tmpDesp = RALINKDESCP(BS);break;\
case 'B'*64 + 'H': tmpDesp = RALINKDESCP(BH);break;\
case 'B'*64 + 'D': tmpDesp = RALINKDESCP(BD);break;\
case 'B'*64 + 'B': tmpDesp = RALINKDESCP(BB);break;\
case 'B'*64 + 'Y': tmpDesp = RALINKDESCP(BY);break;\
case 'B'*64 + 'E': tmpDesp = RALINKDESCP(BE);break;\
case 'B'*64 + 'Z': tmpDesp = RALINKDESCP(BZ);break;\
case 'B'*64 + 'M': tmpDesp = RALINKDESCP(BM);break;\
case 'B'*64 + 'O': tmpDesp = RALINKDESCP(BO);break;\
case 'B'*64 + 'A': tmpDesp = RALINKDESCP(BA);break;\
case 'B'*64 + 'R': tmpDesp = RALINKDESCP(BR);break;\
case 'B'*64 + 'N': tmpDesp = RALINKDESCP(BN);break;\
case 'B'*64 + 'G': tmpDesp = RALINKDESCP(BG);break;\
case 'K'*64 + 'H': tmpDesp = RALINKDESCP(KH);break;\
case 'C'*64 + 'A': tmpDesp = RALINKDESCP(CA);break;\
case 'C'*64 + 'L': tmpDesp = RALINKDESCP(CL);break;\
case 'C'*64 + 'N': tmpDesp = RALINKDESCP(CN);break;\
case 'C'*64 + 'O': tmpDesp = RALINKDESCP(CO);break;\
case 'C'*64 + 'R': tmpDesp = RALINKDESCP(CR);break;\
case 'H'*64 + 'R': tmpDesp = RALINKDESCP(HR);break;\
case 'C'*64 + 'Y': tmpDesp = RALINKDESCP(CY);break;\
case 'C'*64 + 'Z': tmpDesp = RALINKDESCP(CZ);break;\
case 'D'*64 + 'K': tmpDesp = RALINKDESCP(DK);break;\
case 'D'*64 + 'O': tmpDesp = RALINKDESCP(DO);break;\
case 'E'*64 + 'C': tmpDesp = RALINKDESCP(EC);break;\
case 'E'*64 + 'G': tmpDesp = RALINKDESCP(EG);break;\
case 'S'*64 + 'V': tmpDesp = RALINKDESCP(SV);break;\
case 'E'*64 + 'E': tmpDesp = RALINKDESCP(EE);break;\
case 'F'*64 + 'I': tmpDesp = RALINKDESCP(FI);break;\
case 'F'*64 + 'R': tmpDesp = RALINKDESCP(FR);break;\
case 'G'*64 + 'E': tmpDesp = RALINKDESCP(GE);break;\
case 'D'*64 + 'E': tmpDesp = RALINKDESCP(DE);break;\
case 'G'*64 + 'R': tmpDesp = RALINKDESCP(GR);break;\
case 'G'*64 + 'L': tmpDesp = RALINKDESCP(GL);break;\
case 'G'*64 + 'D': tmpDesp = RALINKDESCP(GD);break;\
case 'G'*64 + 'U': tmpDesp = RALINKDESCP(GU);break;\
case 'G'*64 + 'T': tmpDesp = RALINKDESCP(GT);break;\
case 'H'*64 + 'T': tmpDesp = RALINKDESCP(HT);break;\
case 'H'*64 + 'N': tmpDesp = RALINKDESCP(HN);break;\
case 'H'*64 + 'K': tmpDesp = RALINKDESCP(HK);break;\
case 'H'*64 + 'U': tmpDesp = RALINKDESCP(HU);break;\
case 'I'*64 + 'S': tmpDesp = RALINKDESCP(IS);break;\
case 'I'*64 + 'N': tmpDesp = RALINKDESCP(IN);break;\
case 'I'*64 + 'D': tmpDesp = RALINKDESCP(ID);break;\
case 'I'*64 + 'R': tmpDesp = RALINKDESCP(IR);break;\
case 'I'*64 + 'E': tmpDesp = RALINKDESCP(IE);break;\
case 'I'*64 + 'L': tmpDesp = RALINKDESCP(IL);break;\
case 'I'*64 + 'T': tmpDesp = RALINKDESCP(IT);break;\
case 'J'*64 + 'M': tmpDesp = RALINKDESCP(JM);break;\
case 'J'*64 + 'P': tmpDesp = RALINKDESCP(JP);break;\
case 'J'*64 + 'O': tmpDesp = RALINKDESCP(JO);break;\
case 'K'*64 + 'Z': tmpDesp = RALINKDESCP(KZ);break;\
case 'K'*64 + 'E': tmpDesp = RALINKDESCP(KE);break;\
case 'K'*64 + 'P': tmpDesp = RALINKDESCP(KP);break;\
case 'K'*64 + 'R': tmpDesp = RALINKDESCP(KR);break;\
case 'K'*64 + 'W': tmpDesp = RALINKDESCP(KW);break;\
case 'L'*64 + 'V': tmpDesp = RALINKDESCP(LV);break;\
case 'L'*64 + 'B': tmpDesp = RALINKDESCP(LB);break;\
case 'L'*64 + 'I': tmpDesp = RALINKDESCP(LI);break;\
case 'L'*64 + 'T': tmpDesp = RALINKDESCP(LT);break;\
case 'L'*64 + 'U': tmpDesp = RALINKDESCP(LU);break;\
case 'M'*64 + 'O': tmpDesp = RALINKDESCP(MO);break;\
case 'M'*64 + 'K': tmpDesp = RALINKDESCP(MK);break;\
case 'M'*64 + 'Y': tmpDesp = RALINKDESCP(MY);break;\
case 'M'*64 + 'T': tmpDesp = RALINKDESCP(MT);break;\
case 'M'*64 + 'U': tmpDesp = RALINKDESCP(MU);break;\
case 'M'*64 + 'X': tmpDesp = RALINKDESCP(MX);break;\
case 'M'*64 + 'C': tmpDesp = RALINKDESCP(MC);break;\
case 'M'*64 + 'A': tmpDesp = RALINKDESCP(MA);break;\
case 'N'*64 + 'P': tmpDesp = RALINKDESCP(NP);break;\
case 'N'*64 + 'L': tmpDesp = RALINKDESCP(NL);break;\
case 'A'*64 + 'N': tmpDesp = RALINKDESCP(AN);break;\
case 'N'*64 + 'Z': tmpDesp = RALINKDESCP(NZ);break;\
case 'N'*64 + 'I': tmpDesp = RALINKDESCP(NI);break;\
case 'N'*64 + 'O': tmpDesp = RALINKDESCP(NO);break;\
case 'O'*64 + 'M': tmpDesp = RALINKDESCP(OM);break;\
case 'P'*64 + 'K': tmpDesp = RALINKDESCP(PK);break;\
case 'P'*64 + 'A': tmpDesp = RALINKDESCP(PA);break;\
case 'P'*64 + 'G': tmpDesp = RALINKDESCP(PG);break;\
case 'P'*64 + 'Y': tmpDesp = RALINKDESCP(PY);break;\
case 'P'*64 + 'E': tmpDesp = RALINKDESCP(PE);break;\
case 'P'*64 + 'H': tmpDesp = RALINKDESCP(PH);break;\
case 'P'*64 + 'L': tmpDesp = RALINKDESCP(PL);break;\
case 'P'*64 + 'T': tmpDesp = RALINKDESCP(PT);break;\
case 'P'*64 + 'R': tmpDesp = RALINKDESCP(PR);break;\
case 'Q'*64 + 'A': tmpDesp = RALINKDESCP(QA);break;\
case 'R'*64 + 'O': tmpDesp = RALINKDESCP(RO);break;\
case 'R'*64 + 'U': tmpDesp = RALINKDESCP(RU);break;\
case 'R'*64 + 'W': tmpDesp = RALINKDESCP(RW);break;\
case 'S'*64 + 'A': tmpDesp = RALINKDESCP(SA);break;\
case 'R'*64 + 'S': tmpDesp = RALINKDESCP(RS);break;\
case 'M'*64 + 'E': tmpDesp = RALINKDESCP(ME);break;\
case 'S'*64 + 'G': tmpDesp = RALINKDESCP(SG);break;\
case 'S'*64 + 'K': tmpDesp = RALINKDESCP(SK);break;\
case 'S'*64 + 'I': tmpDesp = RALINKDESCP(SI);break;\
case 'Z'*64 + 'A': tmpDesp = RALINKDESCP(ZA);break;\
case 'E'*64 + 'S': tmpDesp = RALINKDESCP(ES);break;\
case 'L'*64 + 'K': tmpDesp = RALINKDESCP(LK);break;\
case 'S'*64 + 'E': tmpDesp = RALINKDESCP(SE);break;\
case 'C'*64 + 'H': tmpDesp = RALINKDESCP(CH);break;\
case 'S'*64 + 'Y': tmpDesp = RALINKDESCP(SY);break;\
case 'T'*64 + 'W': tmpDesp = RALINKDESCP(TW);break;\
case 'T'*64 + 'Z': tmpDesp = RALINKDESCP(TZ);break;\
case 'T'*64 + 'H': tmpDesp = RALINKDESCP(TH);break;\
case 'T'*64 + 'T': tmpDesp = RALINKDESCP(TT);break;\
case 'T'*64 + 'N': tmpDesp = RALINKDESCP(TN);break;\
case 'T'*64 + 'R': tmpDesp = RALINKDESCP(TR);break;\
case 'U'*64 + 'G': tmpDesp = RALINKDESCP(UG);break;\
case 'U'*64 + 'A': tmpDesp = RALINKDESCP(UA);break;\
case 'A'*64 + 'E': tmpDesp = RALINKDESCP(AE);break;\
case 'G'*64 + 'B': tmpDesp = RALINKDESCP(GB);break;\
case 'U'*64 + 'S': tmpDesp = RALINKDESCP(US);break;\
case 'P'*64 + 'S': tmpDesp = RALINKDESCP(PS);break;\
case 'U'*64 + 'Y': tmpDesp = RALINKDESCP(UY);break;\
case 'U'*64 + 'Z': tmpDesp = RALINKDESCP(UZ);break;\
case 'V'*64 + 'E': tmpDesp = RALINKDESCP(VE);break;\
case 'V'*64 + 'N': tmpDesp = RALINKDESCP(VN);break;\
case 'Y'*64 + 'E': tmpDesp = RALINKDESCP(YE);break;\
case 'Z'*64 + 'W': tmpDesp = RALINKDESCP(ZW);break;\
}\
tmpDesp;	\
})

#endif
