/*
 * This file we only ues to format the output file.
 * Copy from Ralink Wireless Driver.
 * Rugemeng 20131209
 */
#ifndef __RALINK_FORMAT_H__
#define __RALINK_FORMAT_H__
#include "local.h"

/*
REGION 	0: 	36-48, 52-64, 149-165 
REGION 	1: 	36-48, 52-64, 100-140
REGION	2:	36-48, 52-64
REGION 	3:	52-64, 149-161
REGION 	4:	149-165
REGION 	5:	149-161
REGION	6:	36-48
REGION	7:	36-48, 52-64, 100-140, 149-165
REGION 	8:	52-64
REGION	9:	36-48, 52-64, 100-116,132-140 149-165
REGION	10:	36-48, 149-165
REGION	11:	36-48, 52-64, 100-120, 149-161
REGION	12:	36-48, 52-64, 100-140
REGION	13:	52-64, 100-140, 149-161
REGION	14:	36-48, 52-64, 100-116,136-140, 149-165
REGION	15:	149-173
REGION	16:	52-64, 149-165
REGION	17:	36-48, 149-161
REGION	18:	36-48, 52-64, 100-116,132-140
REGION	19:	52-60, 100-140, 149-161
REGION	20:	36-48, 52-64, 100-124, 149-161
REGION	21:	36-48, 52-64, 100-140, 149-161
REGION	22:	36-48, 52-64, 132-140, 149-161
REGION 	23:	56-64, 100-116,132-140, 149-165
REGION	24:	36-48, 52-64, 100-132, 149-165
*/

#define A_BAND_REGION_0				0
#define A_BAND_REGION_1				1
#define A_BAND_REGION_2				2
#define A_BAND_REGION_3				3
#define A_BAND_REGION_4				4
#define A_BAND_REGION_5				5
#define A_BAND_REGION_6				6
#define A_BAND_REGION_7				7
#define A_BAND_REGION_8				8
#define A_BAND_REGION_9				9
#define A_BAND_REGION_10				10
	
#define A_BAND_REGION_20				20
#define A_BAND_REGION_21				21
#define A_BAND_REGION_22				22
#define A_BAND_REGION_23				23
#define A_BAND_REGION_24				24

#define G_BAND_REGION_0				0	
#define G_BAND_REGION_1				1	
#define G_BAND_REGION_2				2	
#define G_BAND_REGION_3				3	
#define G_BAND_REGION_4				4	
#define G_BAND_REGION_5				5	
#define G_BAND_REGION_6				6	

#define A_BAND_REGION_0_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND4_BIT)		/* 0, band:1,2,4	*/	
#define A_BAND_REGION_1_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_BIT)		/* 1, band:1,2,3	*/	
#define A_BAND_REGION_2_BIT		(A_BAND1_BIT | A_BAND2_BIT) 					/* 2, band:1,2		*/	
#define A_BAND_REGION_3_BIT		(A_BAND2_BIT | A_BAND4_1_BIT)					/* 3, band:2,4_1	*/	
#define A_BAND_REGION_4_BIT		(A_BAND4_BIT) 								/* 4, band:4		*/	
#define A_BAND_REGION_5_BIT		(A_BAND4_1_BIT)								/* 5, band:4_1		*/	
#define A_BAND_REGION_6_BIT		(A_BAND1_BIT)									/* 6, band:1		*/	
#define A_BAND_REGION_7_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_BIT | A_BAND4_BIT)	/* 7, band:1,2,3,4	*/	
#define A_BAND_REGION_8_BIT		(A_BAND2_BIT)									/* 8, band:2,		*/	
#define A_BAND_REGION_9_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_1_BIT | A_BAND4_BIT)	/* 9, band:1,2,3_1,4*/	
#define A_BAND_REGION_10_BIT		(A_BAND1_BIT | A_BAND4_BIT)	/* 10,band:1,4		*/	

#define A_BAND_REGION_20_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_2_BIT | A_BAND4_1_BIT )
#define A_BAND_REGION_21_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_BIT | A_BAND4_1_BIT )
#define A_BAND_REGION_22_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_3_BIT | A_BAND4_1_BIT )
#define A_BAND_REGION_23_BIT		( A_BAND2_2_BIT | A_BAND3_1_BIT | A_BAND4_BIT )
#define A_BAND_REGION_24_BIT		(A_BAND1_BIT | A_BAND2_BIT | A_BAND3_4_BIT | A_BAND4_BIT )

#define G_BAND_REGION_0_BIT		0x007ff 	/* 0, ch:1-11 	*/		
#define G_BAND_REGION_1_BIT		0x01fff		/* 1, ch:1-13 	*/		
#define G_BAND_REGION_2_BIT		0x00600		/* 2, ch:10-11 	*/		
#define G_BAND_REGION_3_BIT		0x01e00		/* 3, ch:10-13 	*/		
#define G_BAND_REGION_4_BIT		0x02000		/* 4, ch:14 	*/		
#define G_BAND_REGION_5_BIT		0x03fff		/* 5, ch:1-14	*/		
#define G_BAND_REGION_6_BIT		0x001fc		/* 6, ch:3-9	*/		

#define CHKABANDREGION0(x)	(((x).ch5GBit & A_BAND_REGION_0_BIT) == ((x).ch5GBit | A_BAND_REGION_0_BIT))	
#define CHKABANDREGION1(x)	(((x).ch5GBit & A_BAND_REGION_1_BIT) == ((x).ch5GBit | A_BAND_REGION_1_BIT))
#define CHKABANDREGION2(x)	(((x).ch5GBit & A_BAND_REGION_2_BIT) == ((x).ch5GBit | A_BAND_REGION_2_BIT))	
#define CHKABANDREGION3(x)	(((x).ch5GBit & A_BAND_REGION_3_BIT) == ((x).ch5GBit | A_BAND_REGION_3_BIT))	
#define CHKABANDREGION4(x)	(((x).ch5GBit & A_BAND_REGION_4_BIT) == ((x).ch5GBit | A_BAND_REGION_4_BIT))	
#define CHKABANDREGION5(x)	(((x).ch5GBit & A_BAND_REGION_5_BIT) == ((x).ch5GBit | A_BAND_REGION_5_BIT))	
#define CHKABANDREGION6(x)	(((x).ch5GBit & A_BAND_REGION_6_BIT) == ((x).ch5GBit | A_BAND_REGION_6_BIT))	
#define CHKABANDREGION7(x)	(((x).ch5GBit & A_BAND_REGION_7_BIT) == ((x).ch5GBit | A_BAND_REGION_7_BIT))	
#define CHKABANDREGION8(x)	(((x).ch5GBit & A_BAND_REGION_8_BIT) == ((x).ch5GBit | A_BAND_REGION_8_BIT))	
#define CHKABANDREGION9(x)	(((x).ch5GBit & A_BAND_REGION_9_BIT) == ((x).ch5GBit | A_BAND_REGION_9_BIT))	
#define CHKABANDREGION10(x)	(((x).ch5GBit & A_BAND_REGION_10_BIT) == ((x).ch5GBit | A_BAND_REGION_10_BIT))	
#define CHKABANDREGION20(x) 	(((x).ch5GBit & A_BAND_REGION_20_BIT) == ((x).ch5GBit | A_BAND_REGION_20_BIT))	
#define CHKABANDREGION21(x) 	(((x).ch5GBit & A_BAND_REGION_21_BIT) == ((x).ch5GBit | A_BAND_REGION_21_BIT))	
#define CHKABANDREGION22(x) 	(((x).ch5GBit & A_BAND_REGION_22_BIT) == ((x).ch5GBit | A_BAND_REGION_22_BIT))	
#define CHKABANDREGION23(x) 	(((x).ch5GBit & A_BAND_REGION_23_BIT) == ((x).ch5GBit | A_BAND_REGION_23_BIT))	
#define CHKABANDREGION24(x) 	(((x).ch5GBit & A_BAND_REGION_24_BIT) == ((x).ch5GBit | A_BAND_REGION_24_BIT))	

#define CHKGBANDREGION0(x)	(((x).ch2GBit & G_BAND_REGION_0_BIT) == ((x).ch2GBit | G_BAND_REGION_0_BIT))	
#define CHKGBANDREGION1(x)	(((x).ch2GBit & G_BAND_REGION_1_BIT) == ((x).ch2GBit | G_BAND_REGION_1_BIT))		
#define CHKGBANDREGION2(x)	(((x).ch2GBit & G_BAND_REGION_2_BIT) == ((x).ch2GBit | G_BAND_REGION_2_BIT))		
#define CHKGBANDREGION3(x)	(((x).ch2GBit & G_BAND_REGION_3_BIT) == ((x).ch2GBit | G_BAND_REGION_3_BIT))		
#define CHKGBANDREGION4(x)	(((x).ch2GBit & G_BAND_REGION_4_BIT) == ((x).ch2GBit | G_BAND_REGION_4_BIT))		
#define CHKGBANDREGION5(x)	(((x).ch2GBit & G_BAND_REGION_5_BIT) == ((x).ch2GBit | G_BAND_REGION_5_BIT))		
#define CHKGBANDREGION6(x)	(((x).ch2GBit & G_BAND_REGION_6_BIT) == ((x).ch2GBit | G_BAND_REGION_6_BIT))		

#define A_BAND_REGION_0_STR	    "A_BAND_REGION_0"		
#define A_BAND_REGION_1_STR	    "A_BAND_REGION_1"		
#define A_BAND_REGION_2_STR	    "A_BAND_REGION_2"		
#define A_BAND_REGION_3_STR	    "A_BAND_REGION_3"		
#define A_BAND_REGION_4_STR	    "A_BAND_REGION_4"		
#define A_BAND_REGION_5_STR	    "A_BAND_REGION_5"		
#define A_BAND_REGION_6_STR	    "A_BAND_REGION_6"		
#define A_BAND_REGION_7_STR	    "A_BAND_REGION_7"		
#define A_BAND_REGION_8_STR	    "A_BAND_REGION_8"		
#define A_BAND_REGION_9_STR	    "A_BAND_REGION_9"		
#define A_BAND_REGION_10_STR	    "A_BAND_REGION_10"		
#define A_BAND_REGION_20_STR	    "A_BAND_REGION_20"	
#define A_BAND_REGION_21_STR	    "A_BAND_REGION_21"	
#define A_BAND_REGION_22_STR	    "A_BAND_REGION_22"	
#define A_BAND_REGION_23_STR	    "A_BAND_REGION_23"	
#define A_BAND_REGION_24_STR	    "A_BAND_REGION_24"
							    				
#define G_BAND_REGION_0_STR	    "G_BAND_REGION_0"		
#define G_BAND_REGION_1_STR	    "G_BAND_REGION_1"		
#define G_BAND_REGION_2_STR	    "G_BAND_REGION_2"		
#define G_BAND_REGION_3_STR	    "G_BAND_REGION_3"		
#define G_BAND_REGION_4_STR	    "G_BAND_REGION_4"		
#define G_BAND_REGION_5_STR	    "G_BAND_REGION_5"		
#define G_BAND_REGION_6_STR	    "G_BAND_REGION_6"	

#define CHKRLKABAND(chinfo) ({ \
	char *tmp=NULL; \
	if ( CHKABANDREGION0(chinfo)) tmp = A_BAND_REGION_0_STR; \
	else if ( CHKABANDREGION1(chinfo)) tmp = A_BAND_REGION_1_STR; \
	else if ( CHKABANDREGION2(chinfo)) tmp = A_BAND_REGION_2_STR; \
	else if ( CHKABANDREGION3(chinfo)) tmp = A_BAND_REGION_3_STR; \
	else if ( CHKABANDREGION4(chinfo)) tmp = A_BAND_REGION_4_STR; \
	else if ( CHKABANDREGION5(chinfo)) tmp = A_BAND_REGION_5_STR; \
	else if ( CHKABANDREGION6(chinfo)) tmp = A_BAND_REGION_6_STR; \
	else if ( CHKABANDREGION7(chinfo)) tmp = A_BAND_REGION_7_STR; \
	else if ( CHKABANDREGION8(chinfo)) tmp = A_BAND_REGION_8_STR; \
	else if ( CHKABANDREGION9(chinfo)) tmp = A_BAND_REGION_9_STR; \
	else if ( CHKABANDREGION10(chinfo)) tmp = A_BAND_REGION_10_STR; \
	else if ( CHKABANDREGION20(chinfo)) tmp = A_BAND_REGION_20_STR; \
	else if ( CHKABANDREGION21(chinfo)) tmp = A_BAND_REGION_21_STR; \
	else if ( CHKABANDREGION22(chinfo)) tmp = A_BAND_REGION_22_STR; \
	else if ( CHKABANDREGION23(chinfo)) tmp = A_BAND_REGION_23_STR; \
	else if ( CHKABANDREGION24(chinfo)) tmp = A_BAND_REGION_24_STR; \
	else	 printf("Can't match the channle info for country:%d\n", chinfo.countryCode); \
	tmp;	\
	})

#define GETRLKABANDNUM(chinfo) ({ \
	int  tmp=A_BAND_REGION_7; \
	if ( CHKABANDREGION0(chinfo)) tmp = A_BAND_REGION_0; \
	else if ( CHKABANDREGION1(chinfo)) tmp = A_BAND_REGION_1; \
	else if ( CHKABANDREGION2(chinfo)) tmp = A_BAND_REGION_2; \
	else if ( CHKABANDREGION3(chinfo)) tmp = A_BAND_REGION_3; \
	else if ( CHKABANDREGION4(chinfo)) tmp = A_BAND_REGION_4; \
	else if ( CHKABANDREGION5(chinfo)) tmp = A_BAND_REGION_5; \
	else if ( CHKABANDREGION6(chinfo)) tmp = A_BAND_REGION_6; \
	else if ( CHKABANDREGION7(chinfo)) tmp = A_BAND_REGION_7; \
	else if ( CHKABANDREGION8(chinfo)) tmp = A_BAND_REGION_8; \
	else if ( CHKABANDREGION9(chinfo)) tmp = A_BAND_REGION_9; \
	else if ( CHKABANDREGION10(chinfo)) tmp = A_BAND_REGION_10; \
	else if ( CHKABANDREGION20(chinfo)) tmp = A_BAND_REGION_20; \
	else if ( CHKABANDREGION21(chinfo)) tmp = A_BAND_REGION_21; \
	else if ( CHKABANDREGION22(chinfo)) tmp = A_BAND_REGION_22; \
	else if ( CHKABANDREGION23(chinfo)) tmp = A_BAND_REGION_23; \
	else if ( CHKABANDREGION24(chinfo)) tmp = A_BAND_REGION_24; \
	tmp;	\
	})

#define CHKRLKGBAND(chinfo) ({ \
	char *tmp=NULL; \
	if ( CHKGBANDREGION0(chinfo)) tmp = G_BAND_REGION_0_STR; \
	else if ( CHKGBANDREGION1(chinfo)) tmp = G_BAND_REGION_1_STR; \
	else if ( CHKGBANDREGION2(chinfo)) tmp = G_BAND_REGION_2_STR; \
	else if ( CHKGBANDREGION3(chinfo)) tmp = G_BAND_REGION_3_STR; \
	else if ( CHKGBANDREGION4(chinfo)) tmp = G_BAND_REGION_4_STR; \
	else if ( CHKGBANDREGION5(chinfo)) tmp = G_BAND_REGION_5_STR; \
	else if ( CHKGBANDREGION6(chinfo)) tmp = G_BAND_REGION_6_STR; \
	tmp;	\
	})

	
														
#endif
