#!/bin/sh

if [ "$1" = "r" ]
then
	B0=`flash -r 7f0100 -c 1 | sed 's/^.*: //g'`
	B1=`flash -r 7f0101 -c 1 | sed 's/^.*: //g'`
	B2=`flash -r 7f0102 -c 1 | sed 's/^.*: //g'`
	B3=`flash -r 7f0103 -c 1 | sed 's/^.*: //g'`
	B4=`flash -r 7f0104 -c 1 | sed 's/^.*: //g'`
	B5=`flash -r 7f0105 -c 1 | sed 's/^.*: //g'`
	B6=`flash -r 7f0106 -c 1 | sed 's/^.*: //g'`
	B7=`flash -r 7f0107 -c 1 | sed 's/^.*: //g'`
	B8=`flash -r 7f0108 -c 1 | sed 's/^.*: //g'`
	B9=`flash -r 7f0109 -c 1 | sed 's/^.*: //g'`
	echo "Calibration Flag: $B0 $B1 $B2 $B3 $B4 $B5 $B6 $B7 $B8 $B9"
	exit 0
elif [ "$1" = "w" ]
then
	flash -w 0x7f0100 -o 63 1>/dev/null 2>&1
	flash -w 0x7f0101 -o 61 1>/dev/null 2>&1
	flash -w 0x7f0102 -o 6c 1>/dev/null 2>&1
	flash -w 0x7f0103 -o 69 1>/dev/null 2>&1
	flash -w 0x7f0104 -o 62 1>/dev/null 2>&1
	flash -w 0x7f0105 -o 72 1>/dev/null 2>&1
	flash -w 0x7f0106 -o 61 1>/dev/null 2>&1
	flash -w 0x7f0107 -o 74 1>/dev/null 2>&1
	flash -w 0x7f0108 -o 65 1>/dev/null 2>&1
	flash -w 0x7f0109 -o 64 1>/dev/null 2>&1
	echo "Calibration flag has been written in."
	exit 0
else
	echo "Usage: $0 <op> "
	echo "  <op>: r or w (Read or Write calibration flag)"
	echo "Example:"
	echo "	$0 r"
	echo "	$0 w"
	exit 1
fi

