#!/bin/sh

if [ "$1" = "r" ]
then
	B1=`flash -r 1FC00 -c 1 | sed 's/^.*: //g'`
	B2=`flash -r 1FC01 -c 1 | sed 's/^.*: //g'`
	B3=`flash -r 1FC02 -c 1 | sed 's/^.*: //g'`
	B4=`flash -r 1FC03 -c 1 | sed 's/^.*: //g'`
	B5=`flash -r 1FC04 -c 1 | sed 's/^.*: //g'`
	B6=`flash -r 1FC05 -c 1 | sed 's/^.*: //g'`
	echo "mac address: $B1 $B2 $B3 $B4 $B5 $B6"
	exit 0
elif [ "$1" = "w" ]
then
	if [ "$7" = "" ]
	then
		echo "Mac address must be 6 bytes!"
		exit 1
	fi
	flash -w 0x1FC00 -o $2 1>/dev/null 2>&1
	flash -w 0x1FC01 -o $3 1>/dev/null 2>&1
	flash -w 0x1FC02 -o $4 1>/dev/null 2>&1
	flash -w 0x1FC03 -o $5 1>/dev/null 2>&1
	flash -w 0x1FC04 -o $6 1>/dev/null 2>&1
	flash -w 0x1FC05 -o $7 1>/dev/null 2>&1
	exit 0
else
	echo "Usage: $0 <op> [mac_address]"
	echo "  <op>: r or w (Read or Write action)"
	echo "  [mac_address]: MAC[1] MAC[2] MAC[3] MAC[4] MAC[5] MAC[6] (only for write action)"
	echo "Example:"
	echo "	$0 r"
	echo "	$0 w 00 0c 43 68 55 56"
	exit 1
fi

