/******************************************************************************
 *
 * Copyright (c) 2013 TP-LINK Technologies CO.,LTD.
 * All rights reserved.
 *
 * FILE NAME  :   tp_gpio_event.h
 * VERSION    :   1.0
 * DESCRIPTION:   Head file to implement GPIO event detection.
 *
 * AUTHOR     :   Teng Fei <tengfei@tp-link.net>
 * CREATE DATE:   02/10/2014
 *
 * HISTORY    :
 * 01   06/19/2013  Teng Fei     Create.
 *
******************************************************************************/

#ifndef __TP_GPIO_EVENT_H__
#define __TP_GPIO_EVENT_H__

typedef	enum
{
	TP_GPIO_GET_EVT = 0,
	TP_GPIO_SET_EVT = 1
}TP_GPIO_OP;

typedef	enum
{
	TP_GPIO_EVT_NULL = 0,
	TP_GPIO_EVT_RST = 1,
	TP_GPIO_EVT_SYSMOD = 2
}TP_GPIO_EVT;

unsigned gpio_event_gset(const int, const unsigned, const int);
int gpio_thread_init(void);
int gpio_thread_led_init(void);
void gpio_thread_exit(void);

#endif	/* __TP_GPIO_EVENT_H__ */
