#ifndef __TP_MT7620_GPIO_H__
#define __TP_MT7620_GPIO_H__

#include <asm/rt2880/rt_mmap.h>
#include <generated/autoconf.h>


#if defined (CONFIG_RALINK_MT7620)
#define RALINK_GPIO_HAS_7224		1
#endif

#if ! defined (CONFIG_RALINK_RT5350)
#define RALINK_GPIO_LED_LOW_ACT	1
#endif



#define	SYSTEM_MODE_NORMAL_ROUTER	0
#define	SYSTEM_MODE_AP				1
#define	SYSTEM_MODE_APC_ROUTER		2
#define	SYSTEM_MODE_3G_ROUTER		3
#define	SYSTEM_MODE_MAX				4
#define	SYSTEM_MODE_SOFT_ENABLE		19
#define	SYSTEM_MODE_SOFT_DISABLE	20


/* Demo ioctol */
#define  TP_MT7620_GPIO_VALUE_SET	1
#define  TP_MT7620_GPIO_VALUE_CLR	0

/*
 * IOCTL Command Codes
 */
#define	TP_MT7620_GPIO_IOCTL_BASE			0x01
#define	TP_MT7620_GPIO_IOCTL_CMD1      	    TP_MT7620_GPIO_IOCTL_BASE
#define	TP_MT7620_GPIO_IOCTL_CMD2      	    TP_MT7620_GPIO_IOCTL_BASE + 0x01
#define	TP_MT7620_GPIO_IOCTL_CMD3      	    TP_MT7620_GPIO_IOCTL_BASE + 0x02
#define	TP_MT7620_GPIO_IOCTL_CMD4      	    TP_MT7620_GPIO_IOCTL_BASE + 0x03
#define	TP_MT7620_GPIO_IOCTL_CMD5      	    TP_MT7620_GPIO_IOCTL_BASE + 0x04
#define	TP_MT7620_GPIO_IOCTL_CMD6      	    TP_MT7620_GPIO_IOCTL_BASE + 0x05
#define	TP_MT7620_GPIO_IOCTL_MAX			TP_MT7620_GPIO_IOCTL_CMD6
	
#define	TP_MT7620_GPIO_MAGIC 				0xB2
#define	TP_MT7620_GPIO_BTN_READ			    _IOR(TP_MT7620_GPIO_MAGIC, TP_MT7620_GPIO_IOCTL_CMD1, int)
#define	TP_MT7620_GPIO_LED_READ			    _IOR(TP_MT7620_GPIO_MAGIC, TP_MT7620_GPIO_IOCTL_CMD2, int)
#define	TP_MT7620_GPIO_LED_WRITE			_IOW(TP_MT7620_GPIO_MAGIC, TP_MT7620_GPIO_IOCTL_CMD3, int)
	
#define	TP_MT7620_GPIO_USB_LED1_WRITE		_IOW(TP_MT7620_GPIO_MAGIC, TP_MT7620_GPIO_IOCTL_CMD4, int)
#define	TP_MT7620_GPIO_WLANBTN_READ			_IOR(TP_MT7620_GPIO_MAGIC, TP_MT7620_GPIO_IOCTL_CMD5, int)
#define	TP_MT7620_GPIO_MODE_SWITCH			_IOR(TP_MT7620_GPIO_MAGIC, TP_MT7620_GPIO_IOCTL_CMD6, int)
	
/* the major and minor of device /dev/ar7100_gpio_chrdev */
#define	TP_MT7620_DEV_MAJOR            238
#define	TP_MT7620_DEV_MINOR            0

/*
 * Address of RALINK_ Registers
 */
#define TP_MT7620_SYSCTL_ADDR					RALINK_SYSCTL_BASE	// system control
#define TP_MT7620_REG_GPIOMODE				(TP_MT7620_SYSCTL_ADDR + 0x60)

#define RALINK_IRQ_ADDR					RALINK_INTCL_BASE
#define RALINK_PRGIO_ADDR					RALINK_PIO_BASE // Programmable I/O

#if defined (CONFIG_RALINK_MT7620)
#define TP_MT7620_REG_INTENA					(RALINK_IRQ_ADDR   + 0x34)
#define TP_MT7620_REG_INTDIS					(RALINK_IRQ_ADDR   + 0x38)

/*  gpio 23-0 register */
#define TP_MT7620_REG_PIOINT					(RALINK_PRGIO_ADDR + 0x00)
#define TP_MT7620_REG_PIOEDGE				(RALINK_PRGIO_ADDR + 0x04)
#define TP_MT7620_REG_PIORENA				(RALINK_PRGIO_ADDR + 0x08)
#define TP_MT7620_REG_PIOFENA				(RALINK_PRGIO_ADDR + 0x0C)
#define TP_MT7620_REG_PIODATA				(RALINK_PRGIO_ADDR + 0x20)
#define TP_MT7620_REG_PIODIR					(RALINK_PRGIO_ADDR + 0x24)
#define TP_MT7620_REG_PIOPOL					(RALINK_PRGIO_ADDR + 0x28)
#define TP_MT7620_REG_PIOSET					(RALINK_PRGIO_ADDR + 0x2C)
#define TP_MT7620_REG_PIORESET				(RALINK_PRGIO_ADDR + 0x30)
#define TP_MT7620_REG_PIOTOGGLE				(RALINK_PRGIO_ADDR + 0x34)

/*  gpio 39-24 register */
#define TP_MT7620_REG_PIO3924INT				(RALINK_PRGIO_ADDR + 0x38)
#define TP_MT7620_REG_PIO3924EDGE			(RALINK_PRGIO_ADDR + 0x3C)
#define TP_MT7620_REG_PIO3924RENA			(RALINK_PRGIO_ADDR + 0x40)
#define TP_MT7620_REG_PIO3924FENA			(RALINK_PRGIO_ADDR + 0x44)
#define TP_MT7620_REG_PIO3924DATA			(RALINK_PRGIO_ADDR + 0x48)
#define TP_MT7620_REG_PIO3924DIR				(RALINK_PRGIO_ADDR + 0x4C)
#define TP_MT7620_REG_PIO3924POL				(RALINK_PRGIO_ADDR + 0x50)
#define TP_MT7620_REG_PIO3924SET				(RALINK_PRGIO_ADDR + 0x54)
#define TP_MT7620_REG_PIO3924RESET			(RALINK_PRGIO_ADDR + 0x58)
#define TP_MT7620_REG_PIO3924TOGGLE			(RALINK_PRGIO_ADDR + 0x5C)

/*  gpio 71- 40 register */
#define TP_MT7620_REG_PIO7140INT				(RALINK_PRGIO_ADDR + 0x60)
#define TP_MT7620_REG_PIO7140EDGE			(RALINK_PRGIO_ADDR + 0x64)
#define TP_MT7620_REG_PIO7140RENA			(RALINK_PRGIO_ADDR + 0x68)
#define TP_MT7620_REG_PIO7140FENA			(RALINK_PRGIO_ADDR + 0x6C)
#define TP_MT7620_REG_PIO7140DATA			(RALINK_PRGIO_ADDR + 0x70)
#define TP_MT7620_REG_PIO7140DIR				(RALINK_PRGIO_ADDR + 0x74)
#define TP_MT7620_REG_PIO7140POL				(RALINK_PRGIO_ADDR + 0x78)
#define TP_MT7620_REG_PIO7140SET				(RALINK_PRGIO_ADDR + 0x7C)
#define TP_MT7620_REG_PIO7140RESET			(RALINK_PRGIO_ADDR + 0x80)
#define TP_MT7620_REG_PIO7140TOGGLE			(RALINK_PRGIO_ADDR + 0x84)

/*  gpio 72 register */
#define TP_MT7620_REG_PIO72INT				(RALINK_PRGIO_ADDR + 0x88)
#define TP_MT7620_REG_PIO72EDGE				(RALINK_PRGIO_ADDR + 0x8C)
#define TP_MT7620_REG_PIO72RENA				(RALINK_PRGIO_ADDR + 0x90)
#define TP_MT7620_REG_PIO72FENA				(RALINK_PRGIO_ADDR + 0x94)
#define TP_MT7620_REG_PIO72DATA				(RALINK_PRGIO_ADDR + 0x98)
#define TP_MT7620_REG_PIO72DIR				(RALINK_PRGIO_ADDR + 0x9C)
#define TP_MT7620_REG_PIO72POL				(RALINK_PRGIO_ADDR + 0xA0)
#define TP_MT7620_REG_PIO72SET				(RALINK_PRGIO_ADDR + 0xA4)
#define TP_MT7620_REG_PIO72RESET				(RALINK_PRGIO_ADDR + 0xA8)
#define TP_MT7620_REG_PIO72TOGGLE			(RALINK_PRGIO_ADDR + 0xAC)

#define RALINK_INTCTL_PIO		(1<<6)

#endif	/* CONFIG_RALINK_MT7620 */

/*
 * Values for the GPIOMODE Register
 */
#if defined (CONFIG_RALINK_MT7620)
#define TP_MT7620_GPIOMODE_I2C_BIT_0			0
#define TP_MT7620_GPIOMODE_UARTF_BIT_2		2
#define TP_MT7620_GPIOMODE_UARTF_BIT_3		3
#define TP_MT7620_GPIOMODE_UARTF_BIT_4		4
#define TP_MT7620_GPIOMODE_RGMII1_BIT_9		9
#define TP_MT7620_GPIOMODE_WLED_BIT_13		13
#define TP_MT7620_GPIOMODE_WLED_BIT_12		12
#define TP_MT7620_GPIOMODE_EPHY_LED_BIT_15	15

#define TP_MT7620_GPIODIR_BIT0					0
#define TP_MT7620_GPIODIR_BIT1					1
#define TP_MT7620_GPIODIR_BIT2					2
#define TP_MT7620_GPIODIR_BIT7					7
#define TP_MT7620_GPIODIR_BIT8					8
#define TP_MT7620_GPIODIR_BIT9					9
#define TP_MT7620_GPIODIR_BIT10					10

#define TP_MT7620_GPIOPOL_BIT0					0
#define TP_MT7620_GPIOPOL_BIT1					1
#define TP_MT7620_GPIOPOL_BIT2					2
#define TP_MT7620_GPIOPOL_BIT7					7
#define TP_MT7620_GPIOPOL_BIT8					8
#define TP_MT7620_GPIOPOL_BIT9					9
#define TP_MT7620_GPIOPOL_BIT10					10

#define TP_MT7620_GPIODATA_BIT0					0
#define TP_MT7620_GPIODATA_BIT1					1
#define TP_MT7620_GPIODATA_BIT2					2
#define TP_MT7620_GPIODATA_BIT7					7
#define TP_MT7620_GPIODATA_BIT8					8
#define TP_MT7620_GPIODATA_BIT9					9
#define TP_MT7620_GPIODATA_BIT10					10

#define TP_MT7620_GPIOIRQ_BIT6					6

#define TP_MT7620_GLOBAL_IRQ						TP_MT7620_GPIOIRQ_BIT6
#endif

/*
 * bit is the unit of length
 */
#if defined (CONFIG_RALINK_MT7620)
#define TP_MT7620_GPIO_NUMBER				73

#define TP_MT7620_GPIO_DATA_MASK				0x00FFFFFF
#define TP_MT7620_GPIO_FALLING_EDGE			0
#define TP_MT7620_GPIO_RAISE_EDGE			1
#define TP_MT7620_GPIO_DIR_ALLIN				0
#define TP_MT7620_GPIO_DIR_ALLOUT			0x00FFFFFF

typedef enum 
{
        LED_STATE_OFF   =       0,
        LED_STATE_GREEN =       1,
        LED_STATE_YELLOW =      2,
        LED_STATE_ORANGE =      3,
        LED_STATE_MAX =         4
} led_state_e;

#ifndef RST_HOLD_TIME
#define RST_HOLD_TIME						5
#endif	/* RST_HOLD_TIME */

/*
**	For RPT product, we hope that factory default operation triggered at once when RESET button pushed.
*/
#if defined (CONFIG_RALINK_GPIO_RE200)
#undef	RST_HOLD_TIME
#endif

#endif	/* CONFIG_RALINK_MT7620 */

#define TP_MT7620_GPIO(x)					(1 << x)


/*****************************************0.Product Macro Start*************************************/
#if defined (CONFIG_RALINK_GPIO_RE210)
#undef	GPIO_ETHERNET_LED
#undef	GPIO_INTERNET_LED
#undef	GPIO_SYS_LED
#undef	GPIO_TRICOLOR_LED
#undef	GPIO_USB_POWER_OFF
#undef	GPIO_USB_POWER_ON
#undef	GPIO_USB_POWER_SUPPORT
#undef	GPIO_WLAN_LED
#undef	GPIO_WLAN_BACK_END_POST_LED
#undef	GPIO_RANGE_EXTENDER_LED
#undef	WLAN_2G_GPIO_TRICOLOR_LED
#define	LED_POWER_SWITCH_ON_OFF
#define GPIO_POWER_SYSTEM_LED
#define GPIO_2G_LED
#define GPIO_5G_LED
#define GPIO_RANGE_EXTENDER_TRICOLOR_LED
#else
#undef	GPIO_ETHERNET_LED
#undef	GPIO_INTERNET_LED
#undef	GPIO_SYS_LED
#undef	GPIO_TRICOLOR_LED
#undef	GPIO_USB_POWER_OFF
#undef	GPIO_USB_POWER_ON
#undef	GPIO_USB_POWER_SUPPORT
#undef	GPIO_WLAN_LED
#define	GPIO_WLAN_BACK_END_POST_LED
#define	GPIO_RANGE_EXTENDER_LED
#define	WLAN_2G_GPIO_TRICOLOR_LED
#define	LED_POWER_SWITCH_ON_OFF
#endif
/*****************************************0.Product Macro End***************************************/





/*****************************************1.For Control GPIO Start***********************************/
/* product function relaed definitions */
#if defined (CONFIG_RALINK_GPIO_WA3500RE)
	#define	GPIO_WPS_BIT_CONTROL		1
	#define	WLAN_5G_GPIO_TRICOLOR_LED
	#define	GPIO_RESET_FAC_CONTROL		26
#elif defined (CONFIG_RALINK_GPIO_RE200)
	#define	GPIO_WPS_BIT_CONTROL		12
    #define	GPIO_WPS_BIT_CONTROL_DIRVALUE	    TP_MT7620_GPIO_VALUE_CLR
    
	#define	GPIO_RESET_FAC_CONTROL		13
    #define GPIO_RESET_FAC_CONTROL_DIRVALUE     TP_MT7620_GPIO_VALUE_CLR
#elif defined (CONFIG_RALINK_GPIO_RE210)   
	#define	GPIO_WPS_BIT_CONTROL	    12
    #define	GPIO_WPS_BIT_CONTROL_DIRVALUE	    TP_MT7620_GPIO_VALUE_CLR
    
	#define	GPIO_RESET_FAC_CONTROL		13
    #define GPIO_RESET_FAC_CONTROL_DIRVALUE     TP_MT7620_GPIO_VALUE_CLR
    
    #define GPIO_POWER_ONOFF_CONTROL    28
    #define GPIO_POWER_ONOFF_CONTROL_DIRVALUE   TP_MT7620_GPIO_VALUE_CLR
    #define GPIO_POWER_ONOFF_CONTROL_RENAVALUE   TP_MT7620_GPIO_VALUE_SET
    #define GPIO_POWER_ONOFF_CONTROL_FENAVALUE   TP_MT7620_GPIO_VALUE_SET
#else
#endif
/*****************************************1.For Control GPIO End*************************************/




/*****************************************2.Ethernet LED Start***************************************/
#ifdef	GPIO_ETHERNET_LED
#define	GPIO_ETHERNET_LED_BIT_CONTROL		40
#define	GPIO_ETHERNET_LED_BIT_CONTROL_ON	0
#define	GPIO_ETHERNET_LED_BIT_CONTROL_OFF	1

#define	GPIO_ETHERNET_LED_BIT_CONTROL_DIRVALUE TP_MT7620_GPIO_VALUE_SET
#endif	/* GPIO_ETHERNET_LED */
/*****************************************2.Ethernet LED End*****************************************/




/*****************************************3.RE LED Start*********************************************/
#ifdef	GPIO_RANGE_EXTENDER_LED
#if defined (CONFIG_RALINK_GPIO_WA3500RE)
	#define	GPIO_RANGE_EXTENDER_LED_BIT_CONTROL	25
#elif defined (CONFIG_RALINK_GPIO_RE200)
	#define	GPIO_RANGE_EXTENDER_LED_BIT_CONTROL	39	
#endif
#define	GPIO_RANGE_EXTENDER_LED_BIT_CONTROL_ON	0
#define	GPIO_RANGE_EXTENDER_LED_BIT_CONTROL_OFF	1

#define GPIO_RANGE_EXTENDER_LED_BIT_CONTROL_DIRVALUE TP_MT7620_GPIO_VALUE_SET
#endif	/* GPIO_RANGE_EXTENDER_LED */

#ifdef GPIO_RANGE_EXTENDER_TRICOLOR_LED
#define	GPIO_RANGE_EXTENDER_TRICOLOR_LED_BIT_CONTROL0		25
#define	GPIO_RANGE_EXTENDER_TRICOLOR_LED_BIT_CONTROL1		26
#define	GPIO_RANGE_EXTENDER_TRICOLOR_LED_BIT_CONTROL_ON		0
#define	GPIO_RANGE_EXTENDER_TRICOLOR_LED_BIT_CONTROL_OFF    1

#define GPIO_RANGE_EXTENDER_TRICOLOR_LED_GPIOMODE_BIT                   TP_MT7620_GPIOMODE_RGMII1_BIT_9
#define GPIO_RANGE_EXTENDER_TRICOLOR_LED_GPIOMODE_BIT_VALUE             TP_MT7620_GPIO_VALUE_SET

#define GPIO_RANGE_EXTENDER_TRICOLOR_LED_BIT_CONTROL0_DIRVALUE          TP_MT7620_GPIO_VALUE_SET
#define GPIO_RANGE_EXTENDER_TRICOLOR_LED_BIT_CONTROL1_DIRVALUE          TP_MT7620_GPIO_VALUE_SET

#define GPIO_RANGE_EXTENDER_TRICOLOR_LED_PREFIX(xyz) TP_MT7620_REG_PIO3924##xyz 
#endif
/*****************************************3.RE LED End***********************************************/



/*****************************************4.Wlan LED Start*******************************************/
#ifdef	GPIO_WLAN_LED
#define	GPIO_WLAN_LED_BIT_CONTROL
#define	GPIO_WLAN_LED_BIT_ON
#define	GPIO_WLAN_LED_BIT_OFF
#endif	/* GPIO_WLAN_LED */
/*****************************************4.Wlan LED End*********************************************/



/*****************************************5.2G LED Start*********************************************/
#ifdef	WLAN_2G_GPIO_TRICOLOR_LED
#define	WLAN_2G_GPIO_TRICOLOR_LED_BIT_CONTROL0		2
#define	WLAN_2G_GPIO_TRICOLOR_LED_BIT_CONTROL1		72
#define	WLAN_2G_GPIO_TRICOLOR_LED_BIT_CONTROL_ON		0
#define	WLAN_2G_GPIO_TRICOLOR_LED_BIT_CONTROL_OFF		1

#define WLAN_2G_GPIO_TRICOLOR_LED_BIT_CONTROL0_DIRVALUE TP_MT7620_GPIO_VALUE_SET 
#define WLAN_2G_GPIO_TRICOLOR_LED_BIT_CONTROL1_DIRVALUE TP_MT7620_GPIO_VALUE_SET
#endif	/* WLAN_2G_GPIO_TRICOLOR_LED */

#ifdef GPIO_2G_LED
#define GPIO_2G_LED_BIT_CONTROL                    72
#define GPIO_2G_LED_BIT_CONTROL_ON                 0
#define GPIO_2G_LED_BIT_CONTROL_OFF                1

#define GPIO_2G_LED_GPIOMODE_BIT                   TP_MT7620_GPIOMODE_WLED_BIT_13
#define GPIO_2G_LED_GPIOMODE_BIT_VALUE             TP_MT7620_GPIO_VALUE_SET

#define GPIO_2G_LED_BIT_CONTROL_DIRVALUE           TP_MT7620_GPIO_VALUE_SET

#define GPIO_2G_LED_PREFIX(xyz) TP_MT7620_REG_PIO72##xyz
#endif
/*****************************************5.2G LED End**********************************************/



/*****************************************5.5G LED Start*********************************************/
#ifdef	WLAN_5G_GPIO_TRICOLOR_LED
#define	WLAN_5G_GPIO_TRICOLOR_ADDR						0xc0d80228
#define	WLAN_5G_GPIO_TRICOLOR_LED_GREEN_BIT			    2
#define	WLAN_5G_GPIO_TRICOLOR_LED_RED_BIT				1
#define	WLAN_5G_GPIO_TRICOLOR_LED_BIT_CONTROL_ON		0
#define	WLAN_5G_GPIO_TRICOLOR_LED_BIT_CONTROL_OFF		1
#endif	/* WLAN_5G_GPIO_TRICOLOR_LED */

#ifdef GPIO_5G_LED
#define GPIO_5G_LED_BIT_CONTROL                    1
#define GPIO_5G_LED_BIT_CONTROL_ON                 0
#define GPIO_5G_LED_BIT_CONTROL_OFF                1

#define GPIO_5G_LED_GPIOMODE_BIT                   TP_MT7620_GPIOMODE_I2C_BIT_0
#define GPIO_5G_LED_GPIOMODE_BIT_VALUE             TP_MT7620_GPIO_VALUE_SET

#define GPIO_5G_LED_BIT_CONTROL_DIRVALUE           TP_MT7620_GPIO_VALUE_SET

#define GPIO_5G_LED_PREFIX(xyz) TP_MT7620_REG_PIO##xyz
#endif
/*****************************************5.5G LED End***********************************************/



/*****************************************6.Local Wireless LED Start*********************************/
#ifdef	GPIO_WLAN_BACK_END_POST_LED
#define	GPIO_WLAN_BACK_END_LED_BIT_CONTROL		27
#define	GPIO_WLAN_BACK_END_LED_BIT_CONTROL_ON	0
#define	GPIO_WLAN_BACK_END_LED_BIT_CONTROL_OFF	1

#define	GPIO_WLAN_BACK_END_LED_BIT_CONTROL_DIRVALUE TP_MT7620_GPIO_VALUE_SET
#endif	/* GPIO_WLAN_BACK_END_POST_LED */
/*****************************************6.Local Wireless LED End***********************************/



/*****************************************7.Power Switch GPIO Start**********************************/
#ifdef	LED_POWER_SWITCH_ON_OFF
#define	GPIO_LED_POWER_SWITCH_BIT_CONTROL		24
#define	GPIO_LED_POWER_SWITCH_BIT_CONTROL_ON	0
#define	GPIO_LED_POWER_SWITCH_BIT_CONTROL_OFF	1

#if defined(CONFIG_RALINK_GPIO_RE200)
#define	GPIO_LED_POWER_SWITCH_BIT_CONTROL_DIRVALUE    TP_MT7620_GPIO_VALUE_SET
#else
#define	GPIO_LED_POWER_SWITCH_BIT_CONTROL_DIRVALUE    TP_MT7620_GPIO_VALUE_CLR
#define GPIO_LED_POWER_SWITCH_BIT_CONTROL_RENAVALUE   TP_MT7620_GPIO_VALUE_SET
#define GPIO_LED_POWER_SWITCH_BIT_CONTROL_FENAVALUE   TP_MT7620_GPIO_VALUE_SET
#endif

#define GPIO_POWER_SWITCH_LED_PREFIX(xyz) TP_MT7620_REG_PIO3924##xyz
#endif	/* LED_POWER_SWITCH_ON_OFF */
/*****************************************7.Power Switch GPIO End************************************/



/*****************************************8.Power System Led Start***********************************/
#ifdef	GPIO_POWER_SYSTEM_LED
#define	GPIO_POWER_SYSTEM_LED_BIT_CONTROL		27
#define	GPIO_POWER_SYSTEM_LED_BIT_CONTROL_ON	0
#define	GPIO_POWER_SYSTEM_LED_BIT_CONTROL_OFF	1
#define GPIO_POWER_SYSTEM_LED_GPIOMODE_BIT                   TP_MT7620_GPIOMODE_RGMII1_BIT_9
#define GPIO_POWER_SYSTEM_LED_GPIOMODE_BIT_VALUE             TP_MT7620_GPIO_VALUE_SET

#define GPIO_POWER_SYSTEM_LED_BIT_CONTROL_DIRVALUE           TP_MT7620_GPIO_VALUE_SET

#define GPIO_POWER_SYSTEM_LED_PREFIX(xyz) TP_MT7620_REG_PIO3924##xyz
#endif
/*****************************************8.Power System Led End*************************************/



#endif /* __TP_MT7620_GPIO_H__*/

