/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to MediaTek Inc. and/or its licensors.
 * Without the prior written permission of MediaTek inc. and/or its licensors,
 * any reproduction, modification, use or disclosure of MediaTek Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 */
/* MediaTek Inc. (C) 2010. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
 * AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN MEDIATEK SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek Software")
 * have been modified by MediaTek Inc. All revisions are subject to any receiver's
 * applicable license agreements with MediaTek Inc.
 */

#ifndef __MT6575_REG_BASE__
#define __MT6575_REG_BASE__

/* MM sub-system */
#define SYSRAM_BASE 0xF2000000
#define MFG_AXI_BASE 0xF2060000
#define AUDIO_BASE 0xF2071000
#define MMSYS1_CONFIG_BASE 0xF2080000
#define SMI_LARB0_BASE 0xF2081000
#define SMI_LARB1_BASE 0xF2082000
#define SMI_LARB2_BASE 0xF2083000
#define VDEC_BASE 0xF2084000
#define VENC_BASE 0xF2085000
#define R_DMA0_BASE 0xF2086000
#define R_DMA1_BASE 0xF2087000
#define VDO_ROT0_BASE 0xF2088000
#define RGB_ROT0_BASE 0xF2089000
#define VDO_ROT1_BASE 0xF208A000
#define RGB_ROT1_BASE 0xF208B000
#define DPI_BASE 0xF208C000
#define BRZ_BASE 0xF208D000
#define JPG_DMA_BASE 0xF208E000
#define OVL_DMA_BASE 0xF208F000
#define CAMINF_BASE 0xF2090000
#define ISPMEM_BASE 0xF2091000
#define CSI2_BASE 0xF2092000
#define CRZ_BASE  0xF2093000
#define VRZ0_BASE 0xF2094000
#define IMGPROC_BASE 0xF2095000
#define EIS_BASE 0xF2096000
#define SPI_BASE 0xF2097000
#define SCAM_BASE 0xF2098000
#define PRZ0_BASE 0xF2099000
#define PRZ1_BASE 0xF209A000
#define JPG_CODEC_BASE 0xF209B000
#define DSI_BASE 0xF209C000
#define TVC_BASE 0xF209D000
#define TVE_BASE 0xF209E000
#define TV_ROT_BASE 0xF209F000
#define RGB_ROT2_BASE 0xF20A0000
#define LCD_BASE 0xF20A1000
#define FDVT_BASE 0xF20A2000
#define MIPI_CONFG_BASE 0xF20A3000
#define VRZ1_BASE 0xF20A4000
#define MMSYS2_CONFG_BASE 0xF20C0000
#define SMI_LARB3_BASE 0xF20C1000
#define MFG_APB_BASE 0xF20C4000
#define G2D_BASE 0xF20C5000

/* perisys */
#define PERICFG_BASE 0xF1000000
#define AP_DMA_BASE 0xF1001000
#define RTC_BASE 0xF1003000
#define NFI_BASE 0xF1004000
#define NFIECC_BASE 0xF1005000
#define AUXADC_BASE 0xF1006000
//#define USB_BASE 0xF1007000
#define AP_CCIF_BASE 0xF1007000
#define PWM_BASE 0xF1008000
#define KP_BASE 0xF100E000
#define I2C0_BASE 0xF1012000
#define I2C1_BASE 0xF1013000
#define I2C2_BASE 0xF1014000
#define EFUSE_CTR_BASE 0xF1019000
#define SEJ_BASE 0xF101A000
#define TRUE_RNG_BASE 0xF101B000
#define DEVICE_APC0_BASE 0xF101C000
#define DEVICE_APC1_BASE 0xF101D000
#define FPGA_GPO_BASE 0xF101F000
#define USB11_BASE 0xF1200000
#define USB_BASE 0xF1210000
#define MSDC_0_BASE 0xF1220000
#define MSDC_1_BASE 0xF1230000
#define MSDC_2_BASE 0xF1250000
#define MSDC_3_BASE 0xF1240000
#define USB_SIF_BASE 0xF1260000

/* infrasys */
#define AP_RGU_BASE 0xF0000000
#define INFRA_SYS_CFG_BASE 0xF0001000
#define BOOTROM_BASE 0xF0002000
#define EMI_BASE 0xF0003000
#define DRAM_CTR_BASE 0xF0004000
#define GPIO_BASE 0xF0005000
#define SLEEP_BASE 0xF0006000
#define APMIXED_BASE 0xF0007000
#define SMI_BASE 0xF0008000
#define EINT_BASE 0xF000C000
#define INFRA_TOP_MBIST_CTRL_BASE 0xF000D000
#define APMCU_MDM_BASE 0xF000F000
#define SCU_BASE 0xF000A000
#define GIC_CPU_BASE 0xF000A100
#define GIC_DIST_BASE 0xF000B000
#define PL310_BASE 0xF000E000
#define MCUSYS_CFGREG_BASE 0xF0009000
#define INT_POL_CTL0 (MCUSYS_CFGREG_BASE + 0x50)
#define INTERNAL_SRAM_BASE 0xF3000000

#define UART1_BASE 0xF1009000
#define UART2_BASE 0xF100A000
#define UART3_BASE 0xF100B000
#define UART4_BASE 0xF100C000
#define UART5_BASE 0xF100D000
#define APMCU_GPTIMER_BASE 0xF1002000

#define THERMAL_BASE    0xF100F000
#define SMI_LARB0_BASE  0xF2081000
#define SMI_LARB1_BASE  0xF2082000
#define SMI_LARB2_BASE  0xF2083000


#define ACCDET_BASE   0xF1016000


/*  audio analog hw register base   */
#define ABB_MDSYS_BASE 0xFD114000

#define VER_BASE 0xF8000000

#endif  /* !__MT6575_REG_BASE__ */
