/*
**	scripts/kconfig/mconf_tree.h

--	*********************************************************************
||	head file to define/declare Macros, data structure, routines, which will used to find
||	dependency tree for some kernel config. e.g. dependency tree for config  
||	"IP_MULTICAST" is shown as followings:
||   `-- IP_MULTICAST (net/ipv4/Kconfig:10)
||        |-- NET_IPGRE_BROADCAST (net/ipv4/Kconfig:245)
||        |-- IP_MROUTE (net/ipv4/Kconfig:254)
||        |   |-- IP_MROUTE_MULTIPLE_TABLES (net/ipv4/Kconfig:267)
||        |   |-- IP_PIMSM_V1 (net/ipv4/Kconfig:281)
||        |   `-- IP_PIMSM_V2 (net/ipv4/Kconfig:294)
||        `-- QETH (drivers/s390/net/Kconfig:66)
||             |-- QETH_L2 (drivers/s390/net/Kconfig:80)
||             `-- QETH_L3 (drivers/s390/net/Kconfig:88)
--	*********************************************************************

@@	By TengFei, 13/07/01
*/

#ifndef	MCONF_TREE_H
#define	MCONF_TREE_H

#define	CFG_RELIED_TREE_SUPPORT
#ifdef	CFG_RELIED_TREE_SUPPORT

struct kcfg_node
{
	struct kcfg_node *list;
	struct kcfg_node *next;
	struct kcfg_node *pa;

	struct menu* src_menu;
	struct symbol* src_sym;

	/*
	**	List of kcfg_nodes who are related with the same Kconfig file
	*/
	struct kcfg_node *same_file;
};


void mconf_tree_maker(void);
void mconf_tree_getopt(int, char**);

#endif	/* CFG_RELIED_TREE_SUPPORT */

#endif	/* MCONF_TREE_H */

